#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include "spasm.h"

struct spasmConfigStruct *spasm_config;

void spasm_error(int syslevel, char *errstr, ...) {
    va_list arglist;

    va_start(arglist, errstr);
    vfprintf(stderr, errstr, arglist);
    fprintf(stderr, "\n");      /* spasm_error args aren't terminated by \n */
    va_end(arglist);
}

int main(int argc, char **argv) {
    char *stats;
    char value[SPASM_DBT_MAX+1];
    int connect = 0;
    int global_ip_bl = 0;
    int verifymx = 0;
    int rejected = 0;
    int global_wl_helo = 0;
    int greylist = 0;
    int virus = 0;
    int rcpt = 0;
    int i;

    if(argc < 2) {
	fprintf(stderr, "syntax: %s <statsfile> [statsfile2...]\n", argv[0]);
	exit(1);
    }
    stats = argv[1];

    if((spasm_config = spasm_cfg()) == NULL) {
	exit(1);
    }

    for(i=1; i<argc; i++) {
	stats = argv[i];
	memset(value, 0, sizeof(value));
	if(db_lookup_entry(stats, "connect", value)) connect += atoi(value);
	memset(value, 0, sizeof(value));
	if(db_lookup_entry(stats, "global_ip_bl", value)) global_ip_bl += atoi(value);
	memset(value, 0, sizeof(value));
	if(db_lookup_entry(stats, "verifymx", value)) verifymx += atoi(value);
	memset(value, 0, sizeof(value));
	if(db_lookup_entry(stats, "rejected", value)) rejected += atoi(value);
	memset(value, 0, sizeof(value));
	if(db_lookup_entry(stats, "global_wl_helo", value)) global_wl_helo += atoi(value);
	memset(value, 0, sizeof(value));
	if(db_lookup_entry(stats, "greylist", value)) greylist += atoi(value);
	memset(value, 0, sizeof(value));
	if(db_lookup_entry(stats, "virus", value)) virus += atoi(value);
	memset(value, 0, sizeof(value));
	if(db_lookup_entry(stats, "rcpt", value)) rcpt += atoi(value);
    }

    printf("greylist: %d\n", greylist);
    printf("connect: %d\n", connect);
    printf("global_ip_bl: %d\n", global_ip_bl);
    printf("global_wl_helo: %d\n", global_wl_helo);
    printf("verifymx: %d\n", verifymx);
    printf("rcpt: %d\n", rcpt);
    printf("rejected: %d\n", rejected);
    printf("virus: %d\n", virus);

    exit(0);
}
