#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include "spasm.h"

#define SPASM_DAEMON
#include "filters.h"

struct spasmConfigStruct *spasm_config;

void spasm_error(int syslevel, char *errstr, ...) {
    va_list arglist;

    va_start(arglist, errstr);
    vfprintf(stderr, errstr, arglist);
    fprintf(stderr, "\n");      /* spasm_error args aren't terminated by \n */
    va_end(arglist);
}

int main(int argc, char **argv) {
    char *user;
    int userbl;
    const SPASM_FILTER *pfltr;
    int newdb;
    int olddb;

    if(argc < 3) {
	fprintf(stderr, "syntax: %s <user> <newdbtype>\n", argv[0]);
	exit(1);
    }
    user = argv[1];

    if((spasm_config = spasm_cfg()) == NULL) {
        exit(1);
    }

    olddb = spasm_config->filterdb;
    if(strcasecmp(argv[2], "berkeleydb") == 0) newdb = BERKELEY_DB;
#ifdef WITH_MYSQL
    else if(strcasecmp(argv[2], "mysql") == 0) newdb = MYSQL_DB;
#endif
    else {
	fprintf(stderr, "Invalid DB Type: %s\n", argv[2]);
	exit(1);
    }

    pfltr = spasm_filters;
    while(pfltr->db_name) {
	spasm_config->filterdb = olddb;
	userbl = spasm_lookup_filter(user, pfltr->db_name);
	spasm_config->filterdb = newdb;
	spasm_set_filter(user, pfltr->db_name, userbl);
	pfltr++;
    }

    exit(0);
}
