#!/usr/bin/perl -w

use strict;
use CGI;
$CGI::POST_MAX = 1024 * 1024 * 5; # 5MB POST (upload) limit
use MIME::Parser;
use MIME::QuotedPrint;
use MIME::Base64;
use Net::POP3;
use Net::SMTP;
use DB_File;
use Crypt::CBC;
use constant REVISION => q$Revision: 1.73 $;

require "modules/tools.pl";

# Set version string
my $VERSION = "1.0-pre10 " . REVISION;

# URL for the script
my $SCRIPT = "/cgi-bin/spasm-webmail.cgi";

# Location of spasm_cgi_app and optional authuser programs
my $SPASM_CGI_APP = "/var/www/bin/spasm/spasm_cgi_app";

# Log file (optional, must be writable by webserver process)
my $USERLOG = "/var/log/httpd/spasm-webmail.log";

# URL for graphics and icons
my $GFX = "/gfx";

# Where to store user preferences, attachments, et cetera.
# This directory must be writable by the webserver.
my $SPOOLDIR = "/var/www/spasm-webmail";
  
# Path to sendmail, with arguments
my $SENDMAIL = "/usr/sbin/sendmail -oi -t";
  
# Where to send spam reports when user clicks the spam report button
my $SPAM_REPORT = 'spamreport@domain.com';

# Key for encrypting cookie information. Choose your own!
my $ENCRYPTION_KEY = 'askdjfIWQER382735(*#&%j4asdfj23Z';

# Cipher to use (DES, IDEA, Blowfish, Rijndael)
my $ENCRYPTION_CIPHER = 'Rijndael';

# List of domains/servers that we're allowed to read mail from
# The key is the label shown to users on the login screen
# The hash is composed of 'domain', the base domain name which is used to
# create the user's email address; 'popserver', the hostname of the
# domain's pop3 server; 'order', which is an integer defining the order
# in which to display the domains on the login page's menu; and 'emaillogin',
# which is 1 or 0 and defines whether the POP server supports loggin in
# with the user's full email address (username@domain)
my %DOMAINS = (
"domain.com" => { domain => "domain.com", popserver => "mail.domain.com", order => 0, emaillogin => 0}
);

# Example of multi-domain setup for %DOMAINS
#my %DOMAINS = (
#"Domain1" => { domain => "domain.com", popserver => "mail.domain.com", order => 0, emaillogin => 1 },
#"Domain2" => { domain => "domain2.com", popserver => "mail.domain2.com", order => 1, emaillogin => 1 },
#"Domain3" => { domain => "domain3.com", popserver => "mail.domain3.com", order => 2, emaillogin => 0 }
#);

################################
# Edit Below At Your Own Risk! #
################################

#
# Images
# Inbox from GNUMail retrieve_48.tiff
# Compose from GNUMail create_48.tiff
# Addresses from GNUMail addresses_48.tiff
# Options from Gear.xpm
# Logout from gnome-error.png and ShutDown.xpm
# Trash from Recycler.xpm
# Reply from GNUMail reply_48.tiff
# ReplyAll based on GNUMail reply_48.tiff and drag_mails.tiff
# Forward from GNUMail forward_48.tiff
# Email Addresses from GNUMail drag_mails.tiff and add.tiff
#

# Available themes
my @THEMES = ("Mail.App", "IconsOnly", "SmallIcons");

# Default theme
my $THEME = "Mail.App";

# Images are stored in $GFX/$THEME directory
my %ICONSET = (
  'Inbox' => 'mail_retrieve.png',
  'Compose' => 'mail_compose.png',
  'Addresses' => 'mail_addrbook.png',
  'Options' => 'mail_prefs.png',
  'Logout' => 'mail_logout.png',
  'Delete' => 'mail_delete.png',
  'Reply' => 'mail_reply.png',
  'ReplyAll' => 'mail_replyall.png',
  'Forward' => 'mail_forward.png',
  'Send' => 'mail_send.png',
  'Spell' => 'mail_spellcheck.png',
  'Attach' => 'mail_attach.png',
  'SpamReport' => 'mail_spamreport.png',
);

my $CSS = <<EOF;
      BODY { background: white; color: black; font-family: "times new roman", serif; font-size: 1.00em; }
      H1 { font-size: 1.25em; text-align: center; }
      IMG { border: none; }
      TABLE { margin-left: auto; margin-right: auto; }
      FORM { margin-bottom: 0; }
      PRE { font-family: "times new roman", serif; font-size: 1.00em; }
      TD.topbar { color: #FFFFFF; background: #002266; font-size: 1.25em; }
      TH.inboxlabels { background: #D3DCE3; font-size: 1.25em; }
      A:link { text-decoration: none; color: #0000FF; }
      A:visited { text-decoration: none; color: #0000FF; }
      A:hover { text-decoration: none; color: #FF0000; }
      A:active { text-decoration: none; color: #0000FF; }
      IMG.imgbutton { border: 2px; border-style: solid; border-color: #B0B0B0 #000000 #000000 #B0B0B0; }
      A.imgbutton:link { text-decoration: none; color: #000000; }
      A.imgbutton:visited { text-decoration: none; color: #000000; }
      A.imgbutton:hover { text-decoration: none; color: #000000; }
      A.imgbutton:active { text-decoration: none; color: #000000; }
EOF

my $COOKIE_ID = "";
my $COOKIE_PASS = "";
my $COOKIE_DOMAIN = "";

my $cgi = new CGI;

my $NUM_MESSAGES = 0;
my $MAILBOX_SIZE = 0;
my $USERDIR = "";

my $username = $cgi->param('username') || "";
my $domain = $cgi->param('domain') || "";
my $password = $cgi->param('password') || "";
my $password_crypt;

if($password =~ /^{cbc}(.+)$/) { $password = decrypt($1); }
if($password) { $password_crypt = '{cbc}' . encrypt($password); }

# Force lowercase usernames, and strip any leading/trailing spaces
$username = lc($username);
$username =~ s/\s//g;

# Auth cookies
unless($username) {
    $username = $cgi->cookie('spasmWebmailUsername') || '';
    # If a cookie is set, keep it set until they log out
    if($username) { $cgi->param('setcookie', 1); }
}
unless($password) {
    $password = $cgi->cookie('spasmWebmailPassword') || '';
    if($password =~ /^{cbc}(.+)$/) { $password = decrypt($1); }
    if($password) { $password_crypt = '{cbc}' . encrypt($password); }
}

unless($domain) { $domain = $cgi->cookie('spasmWebmailDomain') || ''; }

unless($username and $password and $domain) { printLogin(); }

verifyLogin();

my $submit = $cgi->param('submitfunction')?$cgi->param('submitfunction'):"";
my $viewmessage = $cgi->param('viewmessage');
my $viewattachment = $cgi->param('viewattachment');

if($submit eq "Login" or $submit eq "listMail") { listMail(); }
elsif($submit eq "logout") { logout(); }
elsif($submit eq "composeMail" or $submit eq "composeNewMail") { composeMail(); }
elsif($submit eq "replyMail" or $submit eq "replyAll") { replyMail(); }
elsif($submit eq "forwardMail") { forwardMail(); }
elsif($submit eq "addrbook_to") { listAddressBook("to"); }
elsif($submit eq "addrbook_cc") { listAddressBook("cc"); }
elsif($submit eq "addrbook_bcc") { listAddressBook("bcc"); }
elsif($submit eq "newAttachment") { newAttachment(); }
elsif($submit eq "Attach") { addAttachment(); }
elsif($submit eq "delAttachment") { delAttachment(); }
elsif($submit eq "spellCheck") { spellCheck(); }
elsif($submit eq "sendMail") { sendMail(); }
elsif($submit eq "viewAttachment" or $submit eq "downloadAttachment") { viewAttachment(); }
elsif($submit eq "viewMessage") { viewMessage(); }
elsif($submit eq "reportSpam") { reportSpam(); }
elsif($submit eq "delMessage") { delMessage(); }
elsif($submit eq "viewAddressBook") { viewAddressBook(); }
elsif($submit eq "addAddressBook") { addAddressBook(); }
elsif($submit eq "delAddressBook") { delAddressBook(); }
elsif($submit eq "viewPrefs") { viewPrefs(); }
elsif($submit eq "savePrefs") { savePrefs(); }
elsif($submit eq "viewEmailAddresses") { viewEmailAddresses(); }
elsif($submit eq "addEmailAddress") { addEmailAddress(); }
elsif($submit eq "delEmailAddress") { delEmailAddress(); }
# Cookie logins don't have a $submit
elsif(!$submit) { listMail(); }
else { printError("Invalid Submission: $submit"); }

sub printError {
    printHeader();
    printMenuBar();
    print "<H1>@_</H1>";
    printFooter();
    exit;
}

sub printAttError {
    my $error = join('', @_);
    print <<EOF;
Content-type: text/html

<html>
  <head>
    <style type='text/css'>$CSS</style>
  </head>
  <body>
    <h1>$error</h1>
  </body>
</html>
EOF
}

# Log user actions
sub logAction {
    return unless defined $USERLOG;
    my $message = shift;
    my $logline = localtime(time)."\t$username\@$domain $message (PID $$)\n";
    if(open(LOGFILE, ">>$USERLOG")) {
        if(flock(LOGFILE,2)) {
            print LOGFILE $logline;
        }
        close(LOGFILE);
    } else {
        warn "Error opening logfile: $!";
    }
}

sub logout {
    my $cookie = $cgi->cookie('spasmWebmailUsername') || '';
    if($cookie) {
	$COOKIE_ID = $cgi->cookie(-name=>'spasmWebmailUsername', -value=>"", -expires=>'0', -path=>"$SCRIPT");
	$COOKIE_PASS = $cgi->cookie(-name=>'spasmWebmailPassword', -value=>"", -expires=>'0', -path=>"$SCRIPT");
	$COOKIE_DOMAIN = $cgi->cookie(-name=>'spasmWebmailDomain', -value=>"", -expires=>'0', -path=>"$SCRIPT");
    }
    printLogin();
}

sub encrypt {
    my $plaintext = shift || return;
    my $cipher = Crypt::CBC->new(-key => $ENCRYPTION_KEY, -cipher => $ENCRYPTION_CIPHER) or warn $!;
    my $ciphertext = $cipher->encrypt($plaintext) or warn $!;
    my $encoded = encode_base64($ciphertext);
    chomp $encoded;
    return $encoded;
}

sub decrypt {
    my $encoded = shift || return;
    my $ciphertext = decode_base64($encoded);
    my $cipher = Crypt::CBC->new(-key => $ENCRYPTION_KEY, -cipher => $ENCRYPTION_CIPHER);
    my $plaintext = $cipher->decrypt($ciphertext);
    return $plaintext;
}

sub connectPOP3 {
    my $pop = Net::POP3->new($DOMAINS{$domain}{popserver}, Timeout => 60);
    if(!defined($pop)) {
        sleep 5;
        $pop = Net::POP3->new($DOMAINS{$domain}{popserver}, Timeout => 60);
        if(!defined($pop)) {
            return undef;
        } else {
            return $pop;
        }
    } else {
        return $pop;
    }
}

sub verifyLogin {
    my $pop = connectPOP3() or printAttError("Error connecting to POP server");
    if($DOMAINS{$domain}{emaillogin}) {
	$pop->login("$username\@$DOMAINS{$domain}{domain}", $password) or
	    printLogin("Invalid Username or Password.");
    } else {
	$pop->login($username, $password) or
            printLogin("Invalid Username or Password.");
    }
    my $msgs = $pop->list;
    $NUM_MESSAGES = 0;
    $MAILBOX_SIZE = 0;
    for (keys %$msgs) { $NUM_MESSAGES++; $MAILBOX_SIZE += $msgs->{$_}; }
    $MAILBOX_SIZE = int($MAILBOX_SIZE / 1024); # Convert from octets (bytes) to Ko (kilobytes)
    $pop->quit;

    # Verify user directories exist
    $USERDIR = "$SPOOLDIR/$username\@$DOMAINS{$domain}{domain}";
    mkdir($USERDIR);
    mkdir("$USERDIR/messages");
    mkdir("$USERDIR/attachments");

    # Create default preferences
    tie(my %prefs, 'DB_File', "$USERDIR/prefs.db", O_RDWR|O_CREAT, 0644, $DB_HASH) or
        printError("Error opening preferences: $!");
    unless(defined $prefs{reply_to}) { $prefs{reply_to} = ""; }
    unless(defined $prefs{signature}) { $prefs{signature} = ""; }
    unless(defined $prefs{default_email}) { $prefs{default_email} = "$username\@$DOMAINS{$domain}{domain}"; }
    untie(%prefs);

    tie(%prefs, 'DB_File', "$USERDIR/email_addresses.db", O_RDWR|O_CREAT, 0644, $DB_HASH) or
        printError("Error opening email address database: $!");
    unless(keys %prefs) { $prefs{"$username\@$DOMAINS{$domain}{domain}"} = ""; }
    untie(%prefs);

    # Set cookie if necessary
    my $setcookie = $cgi->param('setcookie') || '';
    if($setcookie or $COOKIE_ID) {
        $COOKIE_ID = $cgi->cookie(-name=>'spasmWebmailUsername', -value=>"$username", -expires=>'+7d', -path=>"$SCRIPT");
        $COOKIE_PASS = $cgi->cookie(-name=>'spasmWebmailPassword', -value=>"$password_crypt", -expires=>'+7d', -path=>"$SCRIPT");
        if(%DOMAINS) {
            $COOKIE_DOMAIN = $cgi->cookie(-name=>'spasmWebmailDomain', -value=>"$domain", -expires=>'+7d', -path=>"$SCRIPT");
        }
    }
    logAction("verified from $ENV{REMOTE_ADDR}");
}

sub printHeader {
    my $title;
    if($username and $domain) {
	$title = "- $username\@$DOMAINS{$domain}{domain}";
    } else {
	$title = "";
    }
    print "Content-type: text/html\n";
    if($COOKIE_ID) { print "Set-Cookie: $COOKIE_ID\n"; }
    if($COOKIE_PASS) { print "Set-Cookie: $COOKIE_PASS\n"; }
    if($COOKIE_DOMAIN) { print "Set-Cookie: $COOKIE_DOMAIN\n"; }
    print "\n";
    print <<EOF;
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<HTML>
  <HEAD>
    <TITLE>spasm webmail $title (v$VERSION)</TITLE>
    <META http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
    <STYLE type="text/css">
$CSS
    </STYLE>
    <SCRIPT type="text/javascript">
      function closeAttachWindow() {
	window.open('', '_attach').close();
      }
      function loginFocus() {
        document.loginForm.elements[0].focus();
      } 
      function passwordFocus() {
        document.loginForm.elements[1].focus();
      }
      function submitFunction(sub, win) {
        if(win == "yes") {
          document.Form1.target="_blank";
        }
        document.Form1.submitfunction.value=sub;
        document.Form1.submit();
        if(win == "yes") {
          document.Form1.target="";
        }
      }
      function confirmAction(msg) {
        if(confirm(msg)) {
          return true;
        } else {
          return false;
        }
      }
      function selectAll() {
        mydoc=document.Form1;
        numElements=mydoc.elements.length;
        for(var i=0;i<numElements;i++) {
          if(mydoc.elements[i].type == 'checkbox') {
            mydoc.elements[i].checked = mydoc.selectUnselect.checked;
          }
        }
      }
      function viewMessage(msg) {
	document.Form1.viewmessage.value=msg;
	submitFunction("viewMessage", 0);
      }
      function toggleHeaders(full) {
	document.Form1.fullheaders.value=full;
	submitFunction("viewMessage", 0);
      }
      function viewAttachment(attnum) {
	document.Form1.viewattachment.value=attnum;
	submitFunction("viewAttachment", 0);
      }
      function downloadAttachment(attnum) {
        document.Form1.viewattachment.value=attnum;
        submitFunction("downloadAttachment", 0);
      }
      function composeMail(rcpt) {
	document.Form1.addrbook_to.value=rcpt;
	submitFunction("composeMail", 0);
      }
      function verifyComposeFields() {
        if(document.Form1.mail_from.value.length == 0) {
          alert("No sender specified");
          return false;
        }

        if(document.Form1.mail_to.value.length == 0) {
          alert("No recipient specified");
          return false;
        }

        if(document.Form1.mail_subject.value.length == 0) {
          alert("No subject specified");
          return false;
        }

        num = document.Form1.mail_to.value.match(/"/g);
        if(num && (num.length % 2)) { alert("Mismatched quotation marks in To: field"); return false; }
    
        num = document.Form1.mail_cc.value.match(/"/g);
        if(num && (num.length % 2)) { alert("Mismatched quotation marks in Cc: field"); return false; }
    
        num = document.Form1.mail_bcc.value.match(/"/g);
        if(num && (num.length % 2)) { alert("Mismatched quotation marks in Bcc: field"); return false; }

        return true;
      }
      function openAddressBook(field) {
	document.Form1.target="_addrbook";
	if(field == "to") {
	  document.Form1.submitfunction.value="addrbook_to";
	  document.Form1.rcpt_list.value=document.Form1.mail_to.value;
	} else if(field == "cc") {
	  document.Form1.submitfunction.value="addrbook_cc";
	  document.Form1.rcpt_list.value=document.Form1.mail_cc.value;
	} else if(field == "bcc") {
	  document.Form1.submitfunction.value="addrbook_bcc";
	  document.Form1.rcpt_list.value=document.Form1.mail_bcc.value;
	}
	window.open("", "_addrbook", "width=400,height=300,resizable=yes,scrollbars=yes");
	document.Form1.submit();
	document.Form1.target="";
	document.Form1.submitfunction.value="";
      }
      function newAttachment() {
	document.Form1.target="_attach";
	window.name = "mainWindow";
	window.open("", "_attach", "width=360,height=300,resizable=yes,scrollbars=yes");
	document.Form1.submitfunction.value="newAttachment";
	document.Form1.submit();
	document.Form1.target="";
	document.Form1.submitfunction.value="";
      }
      function spellCheck() {
	document.Form1.target="_spellcheck";
	window.name = "mainWindow";
	window.open("", "_spellcheck", "width=600,height=400,top=40,left=80,scrollbars=yes,resizable=yes,location=no");
	document.Form1.submitfunction.value="spellCheck";
	document.Form1.submit();
	document.Form1.target="";
	document.Form1.submitfunction.value="";
      }
    </SCRIPT>
  </HEAD>
EOF
}

sub printMenuBar {
    my $title = shift;
    if(!defined $title) { $title = ""; }
    my $extrabuttons = "";
    my $new_compose_window = "";
    my $confirm_delete = "";
    my $confirm_spam = "";

    if(tie(my %prefs, 'DB_File', "$USERDIR/prefs.db", O_RDWR|O_CREAT, 0644, $DB_HASH)) {
	$new_compose_window = $prefs{new_compose_window} || '';
	$confirm_delete = $prefs{confirm_delete} || 'yes';
	$confirm_spam = $prefs{confirm_spam} || 'yes';
	untie(%prefs);
    } else {
	warn "Error opening preference file $USERDIR/prefs.db: $!";
    }

    if($title eq "View Message") {
	if($confirm_delete eq "yes") { $confirm_delete = qq|onClick='return confirmAction("Delete this message?");'|; }
	else { $confirm_delete = ""; }
	if($confirm_spam eq "yes") { $confirm_spam = qq|onClick='return confirmAction("Report this message?");'|; }
	else { $confirm_spam = ""; }

	$extrabuttons = <<EOF;
    <td bgcolor="#DCDCDC" align=right>
      <a class='imgbutton' href='javascript: submitFunction("replyMail", 0);' title="Reply"><img class='imgbutton' src="$GFX/$THEME/$ICONSET{Reply}" align="absmiddle" alt="Reply"></a>
      &nbsp;
      <a class='imgbutton' href='javascript: submitFunction("replyAll", 0);' title="Reply All"><img class='imgbutton' src="$GFX/$THEME/$ICONSET{ReplyAll}" align="absmiddle" alt="Reply All"></a>
      &nbsp;
      <a class='imgbutton' href='javascript: submitFunction("forwardMail", 0);' title="Forward"><img class='imgbutton' src="$GFX/$THEME/$ICONSET{Forward}" align="absmiddle" alt="Forward"></a>
      &nbsp;
      <a class='imgbutton' $confirm_delete href='javascript: submitFunction("delMessage", 0);' title="Delete"><img class='imgbutton' src="$GFX/$THEME/$ICONSET{Delete}" align="absmiddle" alt="Delete"></a>
      &nbsp;
      <a class='imgbutton' $confirm_spam href='javascript: submitFunction("reportSpam", 0);' title="Report Spam"><img class='imgbutton' src="$GFX/$THEME/$ICONSET{SpamReport}" align="absmiddle" alt="Spam"></a>
    </td>
EOF
    }
    elsif($title eq "Inbox") {
        if($confirm_delete eq "yes") { $confirm_delete = qq|onClick='return confirmAction("Delete selected messages?");'|; }
        else { $confirm_delete = ""; }
        if($confirm_spam eq "yes") { $confirm_spam = qq|onClick='return confirmAction("Report selected messages?");'|; }
        else { $confirm_spam = ""; }

	$extrabuttons = <<EOF;
    <td bgcolor="#DCDCDC" align=right>
      <a class='imgbutton' $confirm_delete href='javascript: submitFunction("delMessage", 0);' title="Delete Selected Messages"><img class='imgbutton' src="$GFX/$THEME/$ICONSET{Delete}" align="absmiddle" alt="Delete Selected Messages"></a>
      &nbsp;
      <a class='imgbutton' $confirm_spam href='javascript: submitFunction("reportSpam", 0);' title="Report Spam"><img class='imgbutton' src="$GFX/$THEME/$ICONSET{SpamReport}" align="absmiddle" alt="Spam"></a>
    </td>
EOF
    }
    elsif($title eq "Compose Message") {
	$extrabuttons = <<EOF;
    <td bgcolor="#DCDCDC" align=right>
<!--
      <a class='imgbutton' href='#' title='Spell Check' onClick='spellCheck(); return false;'><img class='imgbutton' src="$GFX/$THEME/$ICONSET{Spell}" align="absmiddle" alt="Spell Check"></a>
      &nbsp;
-->
      <a class='imgbutton' href='#' title='Attach' onClick='newAttachment(); return false;'><img class='imgbutton' src="$GFX/$THEME/$ICONSET{Attach}" align="absmiddle" alt="Attach"></a>
      &nbsp;
      <a class='imgbutton' href='javascript: submitFunction("sendMail", 0);' onClick='return verifyComposeFields();' title='Send'><img class='imgbutton' src="$GFX/$THEME/$ICONSET{Send}" align="absmiddle" alt="Send"></a>
    </td>
EOF
    }

    print <<EOF;
<body>
  <form method=POST enctype="multipart/form-data" action=$SCRIPT name=Form1>
    <input type=hidden name=username value=$username>
    <input type=hidden name=password value=$password_crypt>
    <input type=hidden name=domain value=$domain>
    <input type=hidden name=submitfunction value="">
  <table border=0 align=center width="95%" cellpadding=0 cellspacing=0>
    <tr>
      <td>
        <table border=0 width="100%" cellpadding=0 cellspacing=0>
          <tr>
	    <td class='topbar' nowrap align=left><b>&nbsp;$title</b></td>
	    <td class='topbar' nowrap align=right><b>$NUM_MESSAGES messages / $MAILBOX_SIZE KB &nbsp;</b></td>
	  </tr>
        </table>
      </td>
    </tr>
    <tr>
      <td>
	<table border=0 width="100%" cellpadding=0 cellspacing=0>
	  <tr>
	    <td nowrap bgcolor="#DCDCDC">
	      &nbsp;
	      <a class='imgbutton' href='javascript: submitFunction("listMail", 0);' title='Inbox'><img class='imgbutton' src="$GFX/$THEME/$ICONSET{Inbox}" align="absmiddle" alt="Check Mail"></a>
	      &nbsp;
	      <a class='imgbutton' href='javascript: submitFunction("composeNewMail", "$new_compose_window");' title='Compose'><img class='imgbutton' src="$GFX/$THEME/$ICONSET{Compose}" align="absmiddle" alt="Compose"></a>
	      &nbsp;
	      <a class='imgbutton' href='javascript: submitFunction("viewAddressBook", 0);' title='Address Book'><img class='imgbutton' src="$GFX/$THEME/$ICONSET{Addresses}" align="absmiddle" alt="Address Book"></a>
	      &nbsp;
	      <a class='imgbutton' href='javascript: submitFunction("viewPrefs", 0);' title='Options'><img class='imgbutton' src="$GFX/$THEME/$ICONSET{Options}" align="absmiddle" alt="Options"></a>
	      &nbsp;
	      <a class='imgbutton' href='javascript: submitFunction("logout", 0);' title='Logout'><img class='imgbutton' src="$GFX/$THEME/$ICONSET{Logout}" align="absmiddle" alt="Logout"></a>
	    </td>
	    $extrabuttons
	  </tr>
	</table>
      </td>
    </tr>
  </table>

EOF
}

sub printFooter {
    print <<EOF;
    </FORM>
  </BODY>
</HTML>
EOF
}

sub printLogin {
    my $responsemsg = shift || '';
    my $selectbox;
    my $focusOption;
    for my $key (sort { $DOMAINS{$a}{order} <=> $DOMAINS{$b}{order} } keys(%DOMAINS)) {
        if($key eq $domain) { $selectbox .= "<option value='$key' selected>$key</option>"; }
        else { $selectbox .= "<option value='$key'>$key</option>"; }
    }
    if($username) { $focusOption = "passwordFocus()"; }
    else { $focusOption = "loginFocus()"; }
    printHeader();
    print <<EOF;
  <BODY onLoad="$focusOption">
    <FORM name='loginForm' action='$SCRIPT' method='POST'>
      <table style="margin-left: auto; margin-right: auto; background: #ddddff;" border=1>
        <tr><td>Username:</td><td><input type=text size=16 name=username value="$username"></td></tr>
        <tr><td>Password:</td><td><input type=password size=16 name=password value=""></td></tr>
EOF
    if($selectbox) {
        print "<tr><td align=center>Domain:</td><td align=center><select name=domain>$selectbox</select></td></tr>\n";
    }
    print <<EOF;
        <tr><td align=center colspan=2><input type=checkbox name=setcookie value=1>Keep me logged in</td></tr>
      </table>
      <P style="text-align: center">
        <input type=submit name=submitfunction value="Login">
      </P>
      <P style="text-align: center">
	$responsemsg
      </P>
EOF
    printFooter();
    exit;
}

sub updateMsgsDB {
    my $uidlhash = shift || return;
    if(tie(my %msgsdb, 'DB_File', "$USERDIR/msgs.db", O_RDWR|O_CREAT, 0644, $DB_HASH)) {
        # Populate array of UIDLs
        my @uidls;
        for (keys %$uidlhash) { push @uidls, $uidlhash->{$_}; }
        
        # Remove entries for non-existant messages
        for my $uidl (keys %msgsdb) {
            delete $msgsdb{$uidl} unless grep(/^$uidl$/, @uidls);
        }
    
        # Add new entries
        for my $uidl (@uidls) {
            $msgsdb{$uidl} = "N" unless $msgsdb{$uidl};
        }
	untie(%msgsdb);
    } else {
        warn "Error opening msgs database $USERDIR/msgs.db: $!";                                                                                       
    }                                                                                                                                                  
}

sub listMail {
    logAction("listing mail");
    my $confirm_spam;
    if(tie(my %prefs, 'DB_File', "$USERDIR/prefs.db", O_RDWR|O_CREAT, 0644, $DB_HASH)) {
	$confirm_spam = $prefs{confirm_spam} || 'yes';
	untie(%prefs);
    } else {
	warn "Error opening preference file $USERDIR/prefs.db: $!";
    }
    my $returnmsg = shift || '';
    my $pop = connectPOP3() or printError("Error connecting to POP server");
    if($DOMAINS{$domain}{emaillogin}) {
        $pop->login("$username\@$DOMAINS{$domain}{domain}", $password) or
            printError("Invalid Username or Password.");
    } else {
        $pop->login($username, $password) or
            printError("Invalid Username or Password.");
    }
    my $msgs = $pop->list;
    my $uidls = $pop->uidl;
    updateMsgsDB($uidls);
    $NUM_MESSAGES = 0;
    $MAILBOX_SIZE = 0;
    for (keys %$msgs) { $NUM_MESSAGES++; $MAILBOX_SIZE += $msgs->{$_}; }
    $MAILBOX_SIZE = int($MAILBOX_SIZE / 1024); # Convert from octets (bytes) to Ko (kilobytes)
    printHeader();
    printMenuBar("Inbox");
    print <<EOF;
<p>
<input type=hidden name=viewmessage>
<table style="table-layout: fixed" align=center width=95% cellpadding=1 cellspacing=1 border=0>
  <tr>
    <th class='inboxlabels' width="2%">&nbsp;</th>
    <th class='inboxlabels' align=left width="20%">Date</th>
    <th class='inboxlabels' align=left width="25%">Sender</th>
    <th class='inboxlabels' align=left>Subject</th>
    <th class='inboxlabels' align=right width="6%">Size</th>
    <th width="3%" bgcolor="#D3DCE3"><input type=checkbox name=selectUnselect onClick='selectAll();'></th>
  </tr>
EOF
    tie(my %msgsdb, 'DB_File', "$USERDIR/msgs.db", O_RDWR|O_CREAT, 0644, $DB_HASH) or
	warn "Error opening msgs database $USERDIR/msgs.db: $!";
    my $count = 0;
    for my $i (sort { $b <=> $a } keys %$msgs) {
	$count++;
	my $bgcolor = ($count % 2)?"#EEEEEE":"#DDDDDD";
	my $dateserial;
	my $sender_name;
	my $sender_addr;
	my $subject = "";
	my $numuidl = "$i:$uidls->{$i}";
	my $msgstatus = "";
	my $msgstatustitle = "";

	if($msgsdb{$uidls->{$i}} eq "N") { $msgstatus = "N"; $msgstatustitle = "New Message"; }

	# Retrieval
	my $size = $msgs->{$i};
	if($size > 3145728) { $size = int($size / 1048576); $size .= "MB"; }
	elsif($size > 3072) { $size = int($size / 1024); $size .= "KB"; }
	my $hdrs = $pop->top($i);
	for (@$hdrs) {
	    if(/^From:\s+(.+)/i) { ($sender_name, $sender_addr) = spasm::tools::email2nameaddr($1); }
	    elsif(/^Date:\s+(.+)/i) { $dateserial = spasm::tools::datefield2dateserial($1); }
	    elsif(/^Subject:\s+(.+)/i) { $subject = spasm::tools::decode_mimewords($1); $subject = spasm::tools::str2html($subject); }
	}

	# Formatting
	if($subject and length($subject) > 67) { $subject = substr($subject, 0, 64) . "..."; }
	my $date = $dateserial?spasm::tools::dateserial2str($dateserial, "-0800", "auto", "", 12):"";
	my $sender = $sender_name?$sender_name:$sender_addr;
	unless(defined $sender) { $sender = ""; }

	# Printing
	print <<EOF;
<tr bgcolor='$bgcolor' onMouseOver='this.style.backgroundColor="#FFCCCC"' onMouseOut='this.style.backgroundColor="$bgcolor"'>
<td align=center style='cursor: pointer; color: #28CC00;' onClick='viewMessage("$i")' title="$msgstatustitle">$msgstatus</td>
<td style='cursor: pointer;' onClick='viewMessage("$i")'>$date</td>
<td style='cursor: pointer; overflow: hidden;' onClick='viewMessage("$i")'>$sender</td>
<td style='cursor: pointer;' onClick='viewMessage("$i")' style='overflow: hidden'><a href='javascript: viewMessage("$i");' title='View Message'>$subject</a></td>
<td style='cursor: pointer;' onClick='viewMessage("$i")' align=right>$size</td>
<td align=center><input type=checkbox name=messagelist value="$numuidl"></td>
</tr>
EOF
    }
    if(%msgsdb) { untie(%msgsdb); }
    print "</table></p>\n";
    $pop->quit();

    my $refresh_inbox = "";
    if(tie(my %prefs, 'DB_File', "$USERDIR/prefs.db", O_RDWR|O_CREAT, 0644, $DB_HASH)) {
	$refresh_inbox = $prefs{refresh_inbox} || '';
	if($refresh_inbox eq "5" or $refresh_inbox eq "15" or $refresh_inbox eq "30") {
	    $refresh_inbox *= 60000;
	} else {
	    $refresh_inbox = 0;
	}
	untie(%prefs);
    } else {
	warn "Error opening preference file $USERDIR/prefs.db: $!";
    }
    if($refresh_inbox) {
	print qq|<script type="text/javascript">setTimeout('submitFunction("listMail", 0)',$refresh_inbox);</script>|;
    }

    if($returnmsg eq "spamreport" and $confirm_spam ne "yes") {
	print qq|<script type="text/javascript">alert('Spam report has been sent');</script>|;
    }

    if($returnmsg eq "sendmail") {
	print qq|<script type="text/javascript">alert('Message has been sent');</script>|;
    }

    printFooter();
}

sub viewMessage {
    logAction("viewing message $viewmessage");
    my $returnmsg = shift || '';

    unless(defined $viewmessage) {
	printError("No message number given");
    }

    my %message = ();

    my $fullheaders = $cgi->param('fullheaders');
    unless(defined $fullheaders) { $fullheaders = 0; }

    my $pop = connectPOP3() or printError("Error connecting to POP server");
    if($DOMAINS{$domain}{emaillogin}) {
        $pop->login("$username\@$DOMAINS{$domain}{domain}", $password) or
            printError("Invalid Username or Password.");
    } else {
        $pop->login($username, $password) or
            printError("Invalid Username or Password.");
    }
    my $uidl = $pop->uidl($viewmessage);
    unless($uidl) { printError("Invalid Message."); }
    my @data = @{$pop->get($viewmessage)};
    $pop->quit;

    # Mark message as read in msgs db
    if(tie(my %msgsdb, 'DB_File', "$USERDIR/msgs.db", O_RDWR|O_CREAT, 0644, $DB_HASH)) {
        $msgsdb{$uidl} = "R";
	untie(%msgsdb);
    } else {
        warn "Error opening msgs database $USERDIR/msgs.db: $!";
    }

    # Parse MIME
    my $parser = new MIME::Parser;
    $parser->output_dir("$USERDIR/messages");
    my $mime = $parser->parse_data(\@data);

    # Get headers in array and parse headers for a reply
    my $mail_to = "";
    my $mail_subject = "";
    my $mail_from = "";
    my @hdrs = ();
    while(my $line = shift @data) {
	$line =~ s/^[\r|\n]//g;
	last unless $line;
	push @hdrs, $line;
    }

    # Start body preparation
    my $body = "";
    my $attachments = "";
    my $attnum = -1;
    my $htmlmsg = 0;
    my @inline = ();
    if(my $num_parts = $mime->parts) {
	# Find the displayed message attachment
	for my $i (0..$num_parts) {
	    my $part = $mime->parts($i);
	    next unless defined $part;
	    my $nextpart = $mime->parts($i+1);
	    if(defined($nextpart) and $part->effective_type =~ m#text/#i and !(defined $part->head->recommended_filename) and
		$nextpart->effective_type =~ m#text/#i and !(defined $nextpart->head->recommended_filename)) {
		next;
	    }
	    # We should now be at our displayed message attachment
	    if($part->effective_type =~ m#multipart/alternative#i) {
		my $msgpart = 0;
		my $numsubs = $part->parts;
		for my $i (0..$numsubs) {
		    my $subpart = $part->parts($i);
		    next unless defined $subpart;
		    if($subpart->effective_type =~ m#text/html#i) {
			$msgpart = 1;
			my $part_body = $subpart->stringify_body;
			if($subpart->head->mime_encoding =~ /^quoted-printable/i) {
			    $part_body = decode_qp($part_body);
			} elsif($subpart->head->mime_encoding =~ /^base64/i) {
			    $part_body = decode_base64($part_body);
			}
			$part_body = spasm::tools::html4nobase($part_body);
			$part_body = spasm::tools::html4noframe($part_body);
			$part_body = spasm::tools::html4link($part_body);
			$part_body = spasm::tools::html4disablejs($part_body);
			$part_body = spasm::tools::html4disableembcode($part_body);
			$part_body = spasm::tools::html2table($part_body);
			$body .= "<tr><td colspan=2 bgcolor='#EEEEEE'>$part_body</td></tr>";
			undef $part_body;
		    }
		}
		if(!$msgpart) {
		    for my $i (0..$numsubs) {
			my $subpart = $part->parts($i);
			next unless defined $subpart;
			if($subpart->effective_type =~ m#text/#i) {
			    my $part_body = spasm::tools::text2html($part->stringify_body);
			    $part_body =~ s/^(&gt;.*<br>)$/<font color="#009900">$1<\/font>/img;
			    $body .= "<tr><td colspan=2 bgcolor='#EEEEEE' style='wrap: hard;'>$part_body</td></tr>";
			    undef $part_body;
			}
		    }
		}
	    } elsif($part->effective_type =~ m#text/html#i) {
		my $part_body = $part->stringify_body;
		if($part->head->mime_encoding =~ /^quoted-printable/i) {
		    $part_body = decode_qp($part_body);
		} elsif($part->head->mime_encoding =~ /^base64/i) {
		    $part_body = decode_base64($part_body);
		}
		$part_body = spasm::tools::html4nobase($part_body);
		$part_body = spasm::tools::html4noframe($part_body);
		$part_body = spasm::tools::html4link($part_body);
		$part_body = spasm::tools::html4disablejs($part_body);
		$part_body = spasm::tools::html4disableembcode($part_body);
		$part_body = spasm::tools::html2table($part_body);
		$body .= "<tr><td colspan=2 bgcolor='#EEEEEE'>$part_body</td></tr>";
		undef $part_body;
	    } else {
		# text/plain and unknown text/*
		my $part_body = $part->stringify_body;
		if($part->head->mime_encoding =~ /^quoted-printable/i) {
		    $part_body = decode_qp($part_body);
		} elsif($part->head->mime_encoding =~ /^base64/i) {
		    $part_body = decode_base64($part_body);
		}
		$part_body = spasm::tools::text2html($part_body);
                $part_body =~ s/^(&gt;.*<br>)$/<font color="#009900">$1<\/font>/img;
                $body .= "<tr><td colspan=2 bgcolor='#EEEEEE' style='wrap: hard;'>$part_body</td></tr>";
                undef $part_body;
	    }
	    last;
	}

	# Then display any message/rfc822 attachments
	for my $i (0..$num_parts) {
	    my $part = $mime->parts($i);
	    next unless defined $part;
	    next unless $part->effective_type =~ m#message/rfc822#i;
	    my @subparts = $part->parts;
	    for my $subpart (@subparts) {
		if($subpart->effective_type =~ m#text/plain#i) {
		    my @part_hdrs = split(/\n/, $subpart->stringify_header);
		    my $part_headers = spasm::tools::formatHeader($fullheaders, @part_hdrs);
		    my $part_body = spasm::tools::text2html($subpart->stringify_body);
		    $part_body =~ s/^(&gt;.*<br>)$/<font color="#009900">$1<\/font>/img;
		    $body .= "$part_headers<tr><td colspan=2 bgcolor='#EEEEEE'>$part_body</td></tr>";
		}
	    }
	}

	# Then create links for all attachments
	my @mimeparts = $mime->parts;
	for my $i (0..$num_parts) {
	    my $part = $mime->parts($i);
	    next unless defined $part;
	    my $content_type = $part->effective_type;
	    if($content_type =~ m#message/#i) {
		$attachments .= qq|<tr><td colspan=2 bgcolor='#DDDDDD'><b>Attachment:</b> <a href='javascript: viewAttachment($i);'>[Attached Message] ($content_type)</a></td></tr>\n|;
	    } elsif($content_type =~ m#multipart/#i) {
                my @subparts = $part->parts;
                my $j = -1;
                for my $subpart (@subparts) {
                    $j++;
                    my $content_type = $subpart->effective_type;
                    if($content_type =~ m#message/#i) {
                        $attachments .= qq|<tr><td colspan=2 bgcolor='#DDDDDD'><b>Attachment:</b> <a href='javascript: viewAttachment("$i.$j");'>[Attached Message] ($content_type)</a></td></tr>\n|;
                    } else {
                        my $bodyh = $subpart->bodyhandle;
                        next unless defined $bodyh;
                        my $path = $bodyh->path;
                        next unless defined $path;
                        $path =~ /^.*\/(.*)$/;
                        my $filename = $1;
                        $attachments .= qq|<tr><td colspan=2 bgcolor='#DDDDDD'><b>Attachment:</b> <a href='javascript: viewAttachment("$i.$j");'>$filename ($content_type)</a> <a href='javascript: downloadAttachment("$i.$j");' title='Download Attachment'><img src="$GFX/mail_download.png" align=absmiddle></a></td></tr>\n|;
                    }
                }
	    } else {
		my $bodyh = $part->bodyhandle;
		next unless defined $bodyh;
		my $path = $bodyh->path;
		next unless defined $path;
		$path =~ /^.*\/(.*)$/;
		my $filename = $1;
		$attachments .= qq|<tr><td colspan=2 bgcolor='#DDDDDD'><b>Attachment:</b> <a href='javascript: viewAttachment($i);'>$filename ($content_type)</a> <a href='javascript: downloadAttachment($i);' title='Download Attachment'><img src="$GFX/mail_download.png" align=absmiddle></a></td></tr>\n|;
	    }
	}
	# Remove attachment files
	$parser->filer->purge();
    } else {
	$parser->filer->purge();
	$body = join("", @data);
	undef @data;
	if($mime->effective_type =~ m#text/html#i) {
	    if($mime->head->mime_encoding =~ /^quoted-printable/i) {
		$body = decode_qp($body);
	    } elsif($mime->head->mime_encoding =~ /^base64/i) {
		$body = decode_base64($body);
	    }
            $body = spasm::tools::html4nobase($body);
            $body = spasm::tools::html4noframe($body);
            $body = spasm::tools::html4link($body);
            $body = spasm::tools::html4disablejs($body);
            $body = spasm::tools::html4disableembcode($body);
            #$body = spasm::tools::html4disableemblink($body, $prefs{'disableemblink'}, "$config{'ow_htmlurl'}/images/backgrounds/Transparent.gif") if ($prefs{'disableemblink'} ne 'none');
            #$body = spasm::tools::html4mailto($body, "$config{'ow_cgiurl'}/openwebmail-send.pl", "$urlparm&amp;action=composemessage&amp;message_id=$escapedmessageid&amp;compose_caller=read");
	    $body = spasm::tools::html2table($body);
	} else {
	    # Convert to HTML
	    $body = spasm::tools::text2html($body);
	}
	$body = "<tr><td bgcolor='#EEEEEE' colspan=2>$body</td></tr>\n";
	# Color quotes
	$body =~ s/^(&gt;.*<br>)$/<font color="#00B000">$1<\/font>/img;
    }

    my $formatted_hdrs = spasm::tools::formatHeader($fullheaders, @hdrs);

    printHeader();
    printMenuBar("View Message");

    my $prevbutton = "&nbsp;";
    if($viewmessage < $NUM_MESSAGES) {
	my $msgnum = $viewmessage+1;
	$prevbutton = qq|<a href='javascript: viewMessage("$msgnum")' title='Previous Message'><img src=$GFX/mail_previous.png alt='Previous'></a>|;
    }
    my $nextbutton = "&nbsp;";
    if($viewmessage > 1) {
	my $msgnum = $viewmessage-1;
	$nextbutton = qq|<a href='javascript: viewMessage("$msgnum")' title='Next Message'><img src=$GFX/mail_next.png alt='Next'></a>|;
    }

    print <<EOF;
<p>
<table border=0 width=95% cellspacing=0 cellpadding=1>
  <tr><td align=left>$prevbutton &nbsp; $nextbutton</td></tr>
  $formatted_hdrs
  $attachments
  $body
</table>
</p>
<input type=hidden name=fullheaders value=$fullheaders>
<input type=hidden name=viewmessage value=$viewmessage>
<input type=hidden name=messagelist value="$viewmessage:$uidl">
<input type=hidden name=viewattachment value=''>
<input type=hidden name=mail_to value="$mail_to">
<input type=hidden name=mail_subject value="$mail_subject">
<input type=hidden name=mail_from value="$mail_from">
<input type=hidden name=reply value=0>
<input type=hidden name=lastfunction value="viewMessage">
EOF

    if($returnmsg eq "spamreport") {
	print qq|<script type="text/javascript">alert('Spam report has been sent');</script>|;
    }

    printFooter();
}

sub delMessage {
    logAction("deleting message");
    my @delmsgs = $cgi->param('messagelist');
    unless(@delmsgs) { listMail(); exit; }
    my $pop = connectPOP3() or printError("Error connecting to POP server");
    if($DOMAINS{$domain}{emaillogin}) {
        $pop->login("$username\@$DOMAINS{$domain}{domain}", $password) or
            printError("Invalid Username or Password.");
    } else {
        $pop->login($username, $password) or
            printError("Invalid Username or Password.");
    }
    for(@delmsgs) {
	my ($n, $u) = split(/:/, $_, 2);
	my $uidl = $pop->uidl($n);
	next unless $u and $uidl;
	if($u eq $uidl) { $pop->delete($n); }
    }
    $pop->quit;
    $cgi->delete('messagelist');
    listMail();
}

sub viewAttachment {
    logAction("viewing attachment");
    unless($viewmessage) { printError("No message specified"); }
    unless(defined $viewattachment) { printError("No attachment specified"); }

    my $pop = connectPOP3() or printError("Error connecting to POP server");
    if($DOMAINS{$domain}{emaillogin}) {
        $pop->login("$username\@$DOMAINS{$domain}{domain}", $password) or
            printError("Invalid Username or Password.");
    } else {
        $pop->login($username, $password) or
            printError("Invalid Username or Password.");
    }
    my @data = @{$pop->get($viewmessage)};
    $pop->quit;

    my $attachment;
    my $subattachment;
    if($viewattachment =~ /(\d+)\.(\d+)/) {
        $attachment = $1;
        $subattachment = $2;
    } else {
        $attachment = $viewattachment;
        $subattachment = undef;
    }

    # Parse MIME
    my $parser = new MIME::Parser;
    $parser->output_dir("$USERDIR/messages");
    my $mime = $parser->parse_data(\@data);
    my $part = $mime->parts($attachment);
    my $subpart;
    my $content_type = $part->effective_type;
    my $bodyh = $part->bodyhandle;
    my $path;
    my $filename;
    if(defined $bodyh) {
        $path = $bodyh->path;
        if(defined $path) {
            $path =~ /^.*\/(.*)$/;
            $filename = $1;
        }
    }

    if($content_type =~ m#message/#i) {
	my $foundtxt = 0;
	my @subparts = $part->parts;
	for my $subpart (@subparts) {
	    if($subpart->effective_type =~ m#text/plain#i) {
		print "Content-type: text/plain\n\n", $subpart->stringify_header, "\n", $subpart->stringify_body, "\n";
		$foundtxt = 1;
	    } elsif($subpart->effective_type =~ m#text/html#i) {
                my $hdr = spasm::tools::text2html($subpart->stringify_header);
                print "Content-type: text/html\n\n", $hdr, "\n", $subpart->stringify_body, "\n";
                $foundtxt = 1;
            }
	}
	unless($foundtxt) {
	    $parser->filer->purge();
	    printError("Support not yet implemented for embedded multipart message attachments");
	}
    } elsif($content_type =~ m#multipart/#i) {
        if(defined $subattachment) {
            my $subpart = $part->parts($subattachment);
            my $content_type = $subpart->effective_type;
            if($content_type =~ m#message/#i) {
                my @subparts = $subpart->parts;
                for my $sub (@subparts) {
                    if($sub->effective_type =~ m#text/plain#i) {
                        print "Content-type: text/plain\n\n", $sub->stringify_header, "\n", $sub->stringify_body, "\n";
                    }
                }
            } else {
                $bodyh = $subpart->bodyhandle;
                if(defined $bodyh) {
                    $path = $bodyh->path;
                    if(defined $path) {
                        $path =~ /^.*\/(.*)$/;
                        $filename = $1;
                    }
                }
                print "Content-type: $content_type\n";
                if($submit eq "downloadAttachment") {
                    if($filename) { print "Content-Disposition: attachment; filename=\"$filename\";\n\n"; }
                    else { print "Content-Disposition: attachment;\n\n"; }
                } else {
		    print "\n";
		}
                my $att = $subpart->open("r");
                while(defined(my $line = $att->getline)) { print $line; }
                $att->close;
            }
        } else {
	    $parser->filer->purge();
            printError("Support not implemented for multipart/* attachments");
        }
    } else {
	print "Content-type: $content_type\n";
        print "Content-Disposition: ";
        if($submit eq "downloadAttachment") { print "attachment;"; }
        else { print "inline;"; }
        if($filename) { print "filename=\"$filename\";\n\n"; }
        else { print "\n\n"; }
	my $att = $part->open("r");
	while(defined(my $line = $att->getline)) { print $line; }
	$att->close;
    }
    $parser->filer->purge();
}

sub composeMail {
    logAction("composing message");
    my $closeattwindow = $cgi->param('closeattwindow') || '';
    my $mail_from = "";
    my $mail_to = "";
    my $mail_cc = "";
    my $mail_bcc = "";
    my $mail_replyto;
    my $mail_subject = "";
    my $mail_body = "";
    my $attachments = "";
    my $attach_tr = "";
    if($submit ne "composeNewMail") {
	$mail_from = $cgi->param('mail_from')?$cgi->param('mail_from'):"";
	$mail_to = $cgi->param('mail_to')?$cgi->param('mail_to'):"";
	$mail_cc = $cgi->param('mail_cc')?$cgi->param('mail_cc'):"";
	$mail_bcc = $cgi->param('mail_bcc')?$cgi->param('mail_bcc'):"";
	$mail_replyto = $cgi->param('mail_replyto')?$cgi->param('mail_replyto'):undef;
	$mail_subject = $cgi->param('mail_subject')?$cgi->param('mail_subject'):"";
	$mail_body = $cgi->param('mail_body')?$cgi->param('mail_body'):"";
	my @params = $cgi->param();
	for (@params) {
	    if(/^attachment-(.+)/) {
		my $type = $cgi->param($_) || '';
		$attachments .= qq|$1 ($type)<input type=hidden name='$_' value='$type'><a href='#' title='Remove' onClick='document.Form1.submitfunction.value="delAttachment"; document.Form1.del_attachment.value="$_"; document.Form1.submit();'><img align=absmiddle src='$GFX/mail_remove_att.png' alt='Remove'></a><br>\n|;
	    }
	}
	if($attachments) {
	    $attach_tr = "<tr><td width=13% bgcolor='#DDDDDD' align=right><b>Attachments:</b></td><td bgcolor='#DDDDDD' align=left>$attachments</td></tr>\n";
	}
    }

    tie(my %prefs, 'DB_File', "$USERDIR/prefs.db", O_RDWR|O_CREAT, 0644, $DB_HASH) or
        printError("Error opening preferences: $!");
    unless(defined $mail_replyto) { $mail_replyto = $prefs{reply_to} || ''; }
    unless($mail_from) { $mail_from = $prefs{default_email}?$prefs{default_email}:""; }
    if($prefs{signature} and $mail_body !~ /\Q$prefs{signature}/) {
	$mail_body .= "\n\n\n\n\n$prefs{signature}";
    }
    untie(%prefs); 
        
    my $from_menu = "<select name=mail_from>";
    tie(%prefs, 'DB_File', "$USERDIR/email_addresses.db", O_RDWR|O_CREAT, 0644, $DB_HASH) or
        printError("Error opening email address database: $!");
    for my $key (sort keys(%prefs)) {
	my $selected = "";
	if($prefs{$key}) {
	    $selected = ($mail_from eq "\"$prefs{$key}\" <$key>")?"selected":"";
	    $from_menu .= qq|<option value='&quot;$prefs{$key}&quot; &lt;$key&gt;' $selected>&quot;$prefs{$key}&quot; &lt;$key&gt;</option>|;
	} else {
	    $selected = ($mail_from eq "<$key>")?"selected":"";
	    $from_menu .= qq|<option value='&lt;$key&gt;' $selected>&lt;$key&gt;</option>|;
	}
    } 
    untie(%prefs);
    $from_menu .= "</select>";

    my $addrbook_to = $cgi->param('addrbook_to')?$cgi->param('addrbook_to'):"";
    if($addrbook_to and !$mail_to) {
	tie(%prefs, 'DB_File', "$USERDIR/addrbook.db", O_RDWR|O_CREAT, 0644, $DB_HASH) or
	    printError("Error opening address book: $!");
	$mail_to = "&quot;$addrbook_to&quot; &lt;$prefs{$addrbook_to}&gt;";
	untie(%prefs);
    } else {
	$mail_to = spasm::tools::str2html($mail_to);
    }
    $mail_cc = spasm::tools::str2html($mail_cc);
    $mail_bcc = spasm::tools::str2html($mail_bcc);
    $mail_replyto = spasm::tools::str2html($mail_replyto);
    $mail_subject = spasm::tools::str2html($mail_subject);

    printHeader();
    printMenuBar("Compose Message");
    print <<EOF;
<p>
  $closeattwindow
  <input type=hidden name=rcpt_list value="">
  <input type=hidden name=del_attachment value="">
  <table border=0 width=95% align=center>
    <tr><td width=13% bgcolor='#DDDDDD' align=right><b>From:</b></td><td bgcolor='#DDDDDD' align=left>$from_menu</td></tr>
    <tr><td width=13% bgcolor='#DDDDDD' align=right><b>To:</b></td><td bgcolor='#DDDDDD' align=left><input type=text name=mail_to size=70 value="$mail_to"> <a href='#' title='Address Book' onClick='openAddressBook("to"); return false;'><img src="$GFX/mail_addrbook_24.png" align=absmiddle></a></td></tr>
    <tr><td width=13% bgcolor='#DDDDDD' align=right><b>Cc:</b></td><td bgcolor='#DDDDDD' align=left><input type=text name=mail_cc size=70 value="$mail_cc"> <a href='#' title='Address Book'; onClick='openAddressBook("cc"); return false;'><img src="$GFX/mail_addrbook_24.png" align=absmiddle></a></td></tr>
    <tr><td width=13% bgcolor='#DDDDDD' align=right><b>Bcc:</b></td><td bgcolor='#DDDDDD' align=left><input type=text name=mail_bcc size=70 value="$mail_bcc"> <a href='#' title='Address Book'; onClick='openAddressBook("bcc"); return false;'><img src="$GFX/mail_addrbook_24.png" align=absmiddle></a></td></tr>
    <tr><td width=13% bgcolor='#DDDDDD' align=right><b>Reply-To:</b></td><td bgcolor='#DDDDDD' align=left><input type=text name=mail_replyto size=70 value="$mail_replyto"></td></tr>

    $attach_tr

    <tr><td width=13% bgcolor='#DDDDDD' align=right><b>Subject:</b></td><td bgcolor='#DDDDDD' align=left><input type=text name=mail_subject size=70 value="$mail_subject"></td></tr>
    <tr><td colspan=2 bgcolor='#EEEEEE' align=center><textarea name=mail_body rows=24 cols=78>$mail_body</textarea></td></tr>

    <!--<tr><td colspan=2 bgcolor='#DDDDDD' align=center><input type=submit name=submitbutton value='Send' onClick='document.Form1.submitfunction.value="sendMail";'></td></tr>-->

  </table>
</p>
EOF
    printFooter();
}

sub replyMail {
    logAction("replying to message");
    my %message = ();

    my $fullheaders = $cgi->param('fullheaders');
    unless(defined $fullheaders) { $fullheaders = 0; }

    my $replyall = ($submit eq "replyAll")?1:0;

    my $pop = connectPOP3() or printError("Error connecting to POP server");
    if($DOMAINS{$domain}{emaillogin}) {
        $pop->login("$username\@$DOMAINS{$domain}{domain}", $password) or
            printError("Invalid Username or Password.");
    } else {
        $pop->login($username, $password) or
            printError("Invalid Username or Password.");
    }
    my @data = @{$pop->get($viewmessage)};
    $pop->quit;

    # Parse MIME
    my $parser = new MIME::Parser;
    $parser->output_dir("$USERDIR/messages");
    my $mime = $parser->parse_data(\@data);

    my $mail_to = "";
    my $mail_cc = "";
    my $mail_subject = "";
    my $mail_from = "";
    my $sender_email = "";
    my $sender_name = "";

    # Get headers in array
    my @hdrs = ();
    while(my $line = shift @data) {
        $line =~ s/^[\r|\n]//g;
        last unless $line;
        push @hdrs, $line;
        if($line =~ /^Subject:\s+(.+)/i) {
            $mail_subject = $1;
            if($mail_subject !~ /^Re:/i) {
                $mail_subject = "Re: $mail_subject";
            }
        } elsif($line =~ /^From:\s+(.+)/i) {
	    ($sender_name, $sender_email) = spasm::tools::email2nameaddr($1);
	    unless($mail_to) {
		$mail_to = $1;
		tie(my %addrbook, 'DB_File', "$USERDIR/addrbook.db", O_RDWR|O_CREAT, 0644, $DB_HASH) or
		    printError("Error opening address book: $!");
		for my $key (keys %addrbook) {
		    if(lc($addrbook{$key}) eq lc($sender_email)) {
			$mail_to = "\"$key\" <$addrbook{$key}>";
		    }
		}
		untie(%addrbook);
	    }
        } elsif($line =~ /^Reply-To:\s+(.+)/i) {
            # Reply-To takes priority over From
	    $mail_to = $1;
	    my ($name, $email) = spasm::tools::email2nameaddr($1);
	    tie(my %addrbook, 'DB_File', "$USERDIR/addrbook.db", O_RDWR|O_CREAT, 0644, $DB_HASH) or
		printError("Error opening address book: $!");
	    for my $key (keys %addrbook) {
		if(lc($addrbook{$key}) eq lc($email)) {
		    $mail_to = "\"$key\" <$addrbook{$key}>";
		}
	    }
	    untie(%addrbook);
        } elsif($line =~ /^(?:To|Cc):\s+(.+)/i) {
            my ($name, $email) = spasm::tools::email2nameaddr($1);
            # Check for matching entry in email address database
            tie(my %addrbook, 'DB_File', "$USERDIR/email_addresses.db", O_RDWR|O_CREAT, 0644, $DB_HASH) or
                printError("Error opening email address database: $!");
            for my $key (sort keys(%addrbook)) {
                if(lc($email) eq lc($key)) {
                    $mail_from = "\"$addrbook{$key}\" <$key>";
                }
            }
            untie(%addrbook);
        }
    }

    # Start body preparation
    my $body = "$sender_name wrote:\n\n";
    my $attnum = -1;
    if(my $part = $mime->parts(0)) {
        if($part->effective_type =~ m#text/plain#i) {
	    my @part_body = split(/\n/, $part->stringify_body);
	    for (@part_body) { $body .= "> $_\n"; }
	    undef @part_body;
        } elsif($part->effective_type =~ m#text/html#i) {
	    my $tmp = $part->stringify_body;
	    $tmp = spasm::tools::html2text($tmp);
	    my @part_body = split(/\n/, $tmp);
	    for (@part_body) { $body .= "> $_\n"; }
	    undef $tmp;
	    undef @part_body;
	} elsif($part->effective_type =~ m#multipart/alternative#i) {
	    my $numsubs = $part->parts;
	    for my $i (0..$numsubs) {
		my $subpart = $part->parts($i);
		next unless defined $subpart;
		if($subpart->effective_type =~ m#text/plain#i) {
		    my @part_body = split(/\n/, $subpart->stringify_body);
		    for (@part_body) { $body .= "> $_\n"; }
		    undef @part_body;
		}
	    }
	}
    } else {
	if($mime->effective_type =~ m#text/html#i) {
	    my $tmp = join('', @data);
	    undef @data;
	    $tmp = spasm::tools::html2text($tmp);
	    @data = split(/\n/, $tmp);
	    for (@data) { $body .= "> $_\n"; }
	} else {
	    for (@data) { $body .= "> $_"; }
	}
    }
    undef @data;
    $parser->filer->purge();

    tie(my %prefs, 'DB_File', "$USERDIR/prefs.db", O_RDWR|O_CREAT, 0644, $DB_HASH) or
        printError("Error opening preferences: $!");
    my $mail_replyto = $prefs{reply_to} || '';
    $mail_replyto = spasm::tools::str2html($mail_replyto);
    unless($mail_from) { $mail_from = $prefs{default_email}?$prefs{default_email}:""; }
    if($prefs{signature} and $body !~ /\Q$prefs{signature}/) {
        $body .= "\n\n\n\n\n$prefs{signature}";
    }       
    untie(%prefs); 
        
    my $from_menu = "<select name=mail_from>";
    tie(%prefs, 'DB_File', "$USERDIR/email_addresses.db", O_RDWR|O_CREAT, 0644, $DB_HASH) or
        printError("Error opening email address database: $!");
    for my $key (sort keys(%prefs)) {
        my $selected = "";
        if($prefs{$key}) {
            $selected = ($mail_from eq "\"$prefs{$key}\" <$key>")?"selected":"";
            $from_menu .= qq|<option value='&quot;$prefs{$key}&quot; &lt;$key&gt;' $selected>&quot;$prefs{$key}&quot; &lt;$key&gt;</option>|;
        } else {
            $selected = ($mail_from eq "<$key>")?"selected":"";
            $from_menu .= qq|<option value='&lt;$key&gt;' $selected>&lt;$key&gt;</option>|;
        }
    } 
    untie(%prefs);
    $from_menu .= "</select>";

    # Append remaining recipients if replying to all
    if($replyall) {
        my $to_lines = "";
        my $cc_lines = "";
        my ($from_name, $from_email) = spasm::tools::email2nameaddr($mail_from);
        my ($to_name, $to_email) = spasm::tools::email2nameaddr($mail_to);
        my $continued = "";
        for my $line (@hdrs) {
            if($line =~ /^To:\s+(.+)/i) {
                $continued = "to";
                $to_lines .= "$1 ";
            } elsif($line =~ /^Cc:\s+(.+)/i) {
                $continued = "cc";
                $cc_lines .= "$1 ";
            } elsif($line =~ /^\s+(.+)/i and $continued) {
                if($continued eq "to") { $to_lines .= "$1 "; }
                elsif($continued eq "cc") { $cc_lines .= "$1 "; }
            } else {
                $continued = "";
            }
        }
        my $rcpt_lines = "$to_lines,$cc_lines";
        my @rcpts = split(/,/, $rcpt_lines);
        for my $rcpt (@rcpts) {
            my ($name, $email) = spasm::tools::email2nameaddr($rcpt);
            # Skip self
            if(lc($from_email) eq lc($email)) { next; }
            # Skip $mail_to
            if(lc($to_email) eq lc($email)) { next; }
            # Append to mail_cc
            if($mail_cc) { $mail_cc .= ",$rcpt"; }
            else { $mail_cc = "$rcpt"; }
        }
    }

    $mail_to = spasm::tools::str2html($mail_to);
    $mail_cc = spasm::tools::str2html($mail_cc);

    printHeader();
    printMenuBar("Compose Message");
    print <<EOF;
<p>
  <input type=hidden name=rcpt_list value="">
  <table border=0 width=95% align=center>
    <tr><td width=13% bgcolor='#DDDDDD' align=right><b>From:</b></td><td bgcolor='#DDDDDD' align=left>$from_menu</td></tr>
    <tr><td width=13% bgcolor='#DDDDDD' align=right><b>To:</b></td><td bgcolor='#DDDDDD' align=left><input type=text name=mail_to size=70 value="$mail_to"> <a href='#' title='Address Book' onClick='openAddressBook("to"); return false;'><img src="$GFX/mail_addrbook_24.png" align=absmiddle></a></td></tr>
    <tr><td width=13% bgcolor='#DDDDDD' align=right><b>Cc:</b></td><td bgcolor='#DDDDDD' align=left><input type=text name=mail_cc size=70 value="$mail_cc"> <a href='#' title='Address Book'; onClick='openAddressBook("cc"); return false;'><img src="$GFX/mail_addrbook_24.png" align=absmiddle></a></td></tr>
    <tr><td width=13% bgcolor='#DDDDDD' align=right><b>Bcc:</b></td><td bgcolor='#DDDDDD' align=left><input type=text name=mail_bcc size=70 value=""> <a href='#' title='Address Book'; onClick='openAddressBook("bcc"); return false;'><img src="$GFX/mail_addrbook_24.png" align=absmiddle></a></td></tr>
    <tr><td width=13% bgcolor='#DDDDDD' align=right><b>Reply-To:</b></td><td bgcolor='#DDDDDD' align=left><input type=text name=mail_replyto size=70 value="$mail_replyto"></td></tr>
    <tr><td width=13% bgcolor='#DDDDDD' align=right><b>Subject:</b></td><td bgcolor='#DDDDDD' align=left><input type=text name=mail_subject size=70 value="$mail_subject"></td></tr>
    <tr><td colspan=2 bgcolor='#EEEEEE' align=center><textarea name=mail_body rows=24 cols=78>$body</textarea></td></tr>
  </table>
</p>
EOF
    printFooter();
}

sub forwardMail {
    logAction("forwarding message");
    my %message = ();

    my $fullheaders = $cgi->param('fullheaders');
    unless(defined $fullheaders) { $fullheaders = 0; }

    my $pop = connectPOP3() or printError("Error connecting to POP server");
    if($DOMAINS{$domain}{emaillogin}) {
        $pop->login("$username\@$DOMAINS{$domain}{domain}", $password) or
            printError("Invalid Username or Password.");
    } else {
        $pop->login($username, $password) or
            printError("Invalid Username or Password.");
    }
    my @data = @{$pop->get($viewmessage)};
    $pop->quit;

    # Parse MIME
    my $parser = new MIME::Parser;
    $parser->output_dir("$USERDIR/messages");
    my $mime = $parser->parse_data(\@data);

    my $mail_subject = "";
    my $mail_from = "";

    # Get headers in array
    my @hdrs = ();
    while(my $line = shift @data) {
        $line =~ s/^[\r|\n]//g;
        last unless $line;
        push @hdrs, $line;
        if($line =~ /^Subject:\s+(.+)/i) {
            $mail_subject = "$1 (fwd)";
        } elsif($line =~ /^(?:To|Cc):\s+(.+)/i) {
            my ($name, $email) = spasm::tools::email2nameaddr($1);
            # Check for matching entry in email address database
            tie(my %addrbook, 'DB_File', "$USERDIR/email_addresses.db", O_RDWR|O_CREAT, 0644, $DB_HASH) or
                printError("Error opening email address database: $!");
            for my $key (sort keys(%addrbook)) {
                if(lc($email) eq lc($key)) {
                    $mail_from = "\"$addrbook{$key}\" <$key>";
                }
            }
            untie(%addrbook);
        }
    }
    my $formatted_hdrs = spasm::tools::formatHeader($fullheaders, @hdrs);

    # Start body preparation
    my $body = "---------- Forwarded message ----------\n";
    for my $hdr (@hdrs) {
	if(!$fullheaders) {
	    unless($hdr =~ /^(?:date|from|reply-to|to|cc|bcc|subject):/i) { next; }
	}
	$body .= "$hdr";
    }
    $body .= "\n";
    my $attnum = -1;
    if(my $part = $mime->parts(0)) {
        if($part->effective_type =~ m#text/plain#i) {
	    my $tmp = $part->stringify_body;
	    if($part->head->mime_encoding =~ /^quoted-printable/i) {
                $tmp = decode_qp($tmp);
            } elsif($part->head->mime_encoding =~ /^base64/i) {
                $tmp = decode_base64($tmp);
            }
	    $body .= $tmp;
	    undef $tmp;
        } elsif($part->effective_type =~ m#text/html#i) {
            my $tmp = $part->stringify_body;
            $tmp = spasm::tools::html2text($tmp);
            if($part->head->mime_encoding =~ /^quoted-printable/i) {
                $tmp = decode_qp($tmp);
            } elsif($part->head->mime_encoding =~ /^base64/i) {
                $tmp = decode_base64($tmp);
            }
	    $body .= $tmp;
	    undef $tmp;
	} elsif($part->effective_type =~ m#multipart/alternative#i) {
	    my $numsubs = $part->parts;
	    for my $i (0..$numsubs) {
		my $subpart = $part->parts($i);
		next unless defined $subpart;
		if($subpart->effective_type =~ m#text/plain#i) {
		    my $tmp = $subpart->stringify_body;
                    if($part->head->mime_encoding =~ /^quoted-printable/i) {
                        $tmp = decode_qp($tmp);
                    } elsif($part->head->mime_encoding =~ /^base64/i) {
                        $tmp = decode_base64($tmp);
                    }
		    $body .= $tmp;
		    undef $tmp;
		}
	    }
	}
    } else {
        if($mime->effective_type =~ m#text/html#i) {
            my $tmp = join('', @data);
            undef @data;
            $tmp = spasm::tools::html2text($tmp);
	    $body .= $tmp;
        } else {
            for (@data) { $body .= "$_"; }
        }
    }
    undef @data;

    my $attach_tr = "";
    my $attachments = "";
    for my $part ($mime->parts) {
	if($part->head->recommended_filename) {
	    my $path = $part->bodyhandle->path;
	    my $type = $part->effective_type;
	    $path =~ /^.*\/(.*)$/;
	    my $filename = $1;
	    next unless $filename;
	    `/bin/mv '$USERDIR/messages/$filename' '$USERDIR/attachments/$filename'`;
	    $attachments .= qq|$filename ($type)<input type=hidden name='attachment-$filename' value='$type'><a href='#' title='Remove' onClick='document.Form1.submitfunction.value="delAttachment"; document.Form1.del_attachment.value="attachment-$filename"; document.Form1.submit();'><img align=absmiddle src='$GFX/mail_remove_att.png' alt='Remove'></a><br>\n|;
	}
    }
    if($attachments) {
	$attach_tr = "<tr><td width=13% bgcolor='#DDDDDD' align=right><b>Attachments:</b></td><td bgcolor='#DDDDDD' align=left>$attachments</td></tr>\n";
    }
    $parser->filer->purge();

    tie(my %prefs, 'DB_File', "$USERDIR/prefs.db", O_RDWR|O_CREAT, 0644, $DB_HASH) or
        printError("Error opening preferences: $!");
    my $mail_replyto = $prefs{reply_to} || '';
    $mail_replyto = spasm::tools::str2html($mail_replyto);
    unless($mail_from) { $mail_from = $prefs{default_email}?$prefs{default_email}:""; }
    if($prefs{signature} and $body !~ /\Q$prefs{signature}/) {
        $body = "\n\n\n\n\n$prefs{signature}\n\n$body";
    }       
    untie(%prefs);

    my $from_menu = "<select name=mail_from>";
    tie(%prefs, 'DB_File', "$USERDIR/email_addresses.db", O_RDWR|O_CREAT, 0644, $DB_HASH) or
        printError("Error opening email address database: $!");
    for my $key (sort keys(%prefs)) {
        my $selected = "";
        if($prefs{$key}) {
            $selected = ($mail_from eq "\"$prefs{$key}\" <$key>")?"selected":"";
            $from_menu .= qq|<option value='&quot;$prefs{$key}&quot; &lt;$key&gt;' $selected>&quot;$prefs{$key}&quot; &lt;$key&gt;</option>|;
        } else {
            $selected = ($mail_from eq "<$key>")?"selected":"";
            $from_menu .= qq|<option value='&lt;$key&gt;' $selected>&lt;$key&gt;</option>|;
        }
    } 
    untie(%prefs);
    $from_menu .= "</select>";

    printHeader();
    printMenuBar("Compose Message");
    print <<EOF;
<p>
  <input type=hidden name=rcpt_list value="">
  <input type=hidden name=del_attachment value="">
  <table border=0 width=95% align=center>
    <tr><td width=13% bgcolor='#DDDDDD' align=right><b>From:</b></td><td bgcolor='#DDDDDD' align=left>$from_menu</td></tr>
    <tr><td width=13% bgcolor='#DDDDDD' align=right><b>To:</b></td><td bgcolor='#DDDDDD' align=left><input type=text name=mail_to size=70 value=""> <a href='#' title='Address Book' onClick='openAddressBook("to"); return false;'><img src="$GFX/mail_addrbook_24.png" align=absmiddle></a></td></tr>
    <tr><td width=13% bgcolor='#DDDDDD' align=right><b>Cc:</b></td><td bgcolor='#DDDDDD' align=left><input type=text name=mail_cc size=70 value=""> <a href='#' title='Address Book'; onClick='openAddressBook("cc"); return false;'><img src="$GFX/mail_addrbook_24.png" align=absmiddle></a></td></tr>
    <tr><td width=13% bgcolor='#DDDDDD' align=right><b>Bcc:</b></td><td bgcolor='#DDDDDD' align=left><input type=text name=mail_bcc size=70 value=""> <a href='#' title='Address Book'; onClick='openAddressBook("bcc"); return false;'><img src="$GFX/mail_addrbook_24.png" align=absmiddle></a></td></tr>
    <tr><td width=13% bgcolor='#DDDDDD' align=right><b>Reply-To:</b></td><td bgcolor='#DDDDDD' align=left><input type=text name=mail_replyto size=70 value="$mail_replyto"></td></tr>
    $attach_tr
    <tr><td width=13% bgcolor='#DDDDDD' align=right><b>Subject:</b></td><td bgcolor='#DDDDDD' align=left><input type=text name=mail_subject size=70 value="$mail_subject"></td></tr> 
    <tr><td colspan=2 bgcolor='#EEEEEE' align=center><textarea name=mail_body rows=24 cols=78>$body</textarea></td></tr>
  </table>
</p>
EOF
    printFooter();
}

sub spellCheck {
    printError("Not yet implemented");
}

sub newAttachment {
    logAction("loading new attachment");
    my $mail_from = $cgi->param('mail_from') || '';
    my $mail_to = $cgi->param('mail_to') || '';
    my $mail_cc = $cgi->param('mail_cc') || '';
    my $mail_bcc = $cgi->param('mail_bcc') || '';
    my $mail_replyto = $cgi->param('mail_replyto') || '';
    my $mail_subject = $cgi->param('mail_subject') || '';
    my $mail_body = $cgi->param('mail_body') || '';
    for($mail_from, $mail_to, $mail_cc, $mail_bcc, $mail_replyto, $mail_subject, $mail_body) {
	$_ = spasm::tools::str2html($_);
    }
    my $attachments = "";
    my @params = $cgi->param();
    for (@params) {
        if(/^attachment-.+/) {
            my $type = $cgi->param($_) || '';
            $attachments .= qq|<input type=hidden name="$_" value='$type'>|;
        }
    }
    print <<EOF;
Content-type: text/html

<html>
  <head>
    <style type="text/css">$CSS</style>
    <script type="text/javascript">
      function showLoading() {
	//document.attachmentForm.submit();
	document.getElementById("fileinput").style.visibility = "hidden";
	document.getElementById("message").style.visibility = "visible";
	document.getElementById("buttons").style.visibility = "hidden";
      }
    </script>
  </head>
  <body>
    <table border=0 align=center width=95% cellpadding=0 cellspacing=0>
      <tr><td bgcolor="#002266"><font color="#FFFFFF"><b>Add Attachment</b></font></td></tr>
    </table>
    <form action=$SCRIPT method=post enctype="multipart/form-data" name=attachmentForm target="mainWindow">
      <input type=hidden name=username value="$username">
      <input type=hidden name=password value="$password_crypt">
      <input type=hidden name=domain value="$domain">
      <input type=hidden name=mail_from value="$mail_from">
      <input type=hidden name=mail_to value="$mail_to">
      <input type=hidden name=mail_cc value="$mail_cc">
      <input type=hidden name=mail_bcc value="$mail_bcc">
      <input type=hidden name=mail_replyto value="$mail_replyto">
      <input type=hidden name=mail_subject value="$mail_subject">
      <input type=hidden name=mail_body value="$mail_body">
      $attachments
      <p>
      <table border=0 align=center width=95% cellpadding=0 cellspacing=0>
	<tr id=fileinput><td align=center><input type=file name=new_attachment size=30></td></tr>
	<tr id=message style="visibility: hidden;"><td align=center><b>Loading...</b></td></tr>
      </table>
      </p>
      <div id=buttons>
        <center>
          <input type=submit name=submitfunction value="Attach" onClick="showLoading();">
          <input type=submit name=submitbutton value="Close" onClick="window.close();">
        </center>
      </div>
    </form>
  </body>
</html>
EOF
}

sub addAttachment {
    logAction("adding attachment");
    my $buffer;
    #$CGITempFile::TMPDIRECTORY="$USERDIR/attachments";
    my $file = $cgi->upload('new_attachment') || '';
    unless($file) {
	printAttError("Invalid file attachment: $!");
	exit;
	#composeMail();
    }
    $file =~ /(?:.*[\\|\/])?(.+)$/;
    my $filename = $1;
    open(OF, ">$USERDIR/attachments/$filename") or printError("Error uploading file: $!");
    while(read($file, $buffer, 1024)) { print OF $buffer; }
    close(OF) or printError("Error uploading file: $!");
    $filename =~ s/'/&#39;/g;
    $cgi->param("attachment-$filename", $cgi->uploadInfo($file)->{'Content-Type'});
    $cgi->param('closeattwindow', '<script type="text/javascript">closeAttachWindow();</script>');
    composeMail();
}

sub delAttachment {
    logAction("deleting attachment");
    my $filename = $cgi->param('del_attachment') || '';
    if($filename) {
	$filename =~ /^attachment-(.+)/;
	unlink("$USERDIR/attachments/$1");
    }
    $cgi->delete("$filename");
    composeMail();
}

sub sendMail {
    logAction("sending message");
    my $errors; # For RCPT errors
    my @rcpts;
    my $mime;

    # Check required variables: From, To, Subject
    my $mail_from = $cgi->param('mail_from')?$cgi->param('mail_from'):"";
    unless($mail_from) { printError("No sender specified"); }
    my $mail_to = $cgi->param('mail_to')?$cgi->param('mail_to'):"";
    unless($mail_to) { printError("No recipient specified"); }
    my $mail_subject = $cgi->param('mail_subject')?$cgi->param('mail_subject'):"";
    unless($mail_subject) { printError("No subject specified"); }

    # Check optional variables: Cc, Bcc, Reply-To, Attachment[s]
    my $mail_cc = $cgi->param('mail_cc')?$cgi->param('mail_cc'):"";
    my $mail_bcc = $cgi->param('mail_bcc')?$cgi->param('mail_bcc'):"";
    my $mail_replyto = $cgi->param('mail_replyto')?$cgi->param('mail_replyto'):"";

    # Substitute ; with , when separating multiple recipients
    $mail_to =~ s/;/,/g;
    $mail_cc =~ s/;/,/g;
    $mail_bcc =~ s/;/,/g;

    # Get message body (blank is Ok)
    my $mail_body = $cgi->param('mail_body')?$cgi->param('mail_body'):"";
    $mail_body .= "\n";

    # Get preferences
    tie(my %prefs, 'DB_File', "$USERDIR/prefs.db", O_RDWR|O_CREAT, 0644, $DB_HASH) or
	printError("Error opening preferences: $!");
    my $bcc_self = $prefs{bcc_self} || '';
    untie(%prefs);
    if($bcc_self eq "yes") {
	if($mail_bcc) {
	    $mail_bcc .= ",$mail_from";
	} else {
	    $mail_bcc = "$mail_from";
	}
    }

    # Create headers
    my @msgdata;
    push @msgdata, "From: $mail_from\n";
    push @msgdata, "To: $mail_to\n";
    if($mail_cc) { push @msgdata, "Cc: $mail_cc\n"; }
    if($mail_bcc) { push @msgdata, "Bcc: $mail_bcc\n"; }
    if($mail_replyto) { push @msgdata, "Reply-To: $mail_replyto\n"; }
    push @msgdata, "Subject: $mail_subject\n";
    push @msgdata, "\n"; # Header separator

    # Attachments
    my %attachments = ();
    for ($cgi->param()) {
	if(/^attachment-(.+)/) {
	    my $filename = $1;
	    $attachments{$filename} = $cgi->param($_);
	}
    }
    if(keys(%attachments)) {
	my %mime_create;
	$mime_create{'Type'} = "multipart/mixed";
	$mime_create{'Encoding'} = "7bit";
	$mime_create{'From'} = $mail_from;
	$mime_create{'To'} = $mail_to;
	$mime_create{'Subject'} = $mail_subject;
	if($mail_cc) { $mime_create{'Cc'} = $mail_cc; }
	if($mail_bcc) { $mime_create{'Bcc'} = $mail_bcc; }
	if($mail_replyto) { $mime_create{'Reply-To'} = $mail_replyto; }
	$mime = MIME::Entity->build(%mime_create);
        $mime->attach(Data => $mail_body, Encoding => "7bit", Type => "text/plain");
	for my $filename (keys %attachments) {
	    my $encoding = ($attachments{$filename} =~ /^text\//i)?"7bit":"base64";
            $mime->attach(Path=>"$USERDIR/attachments/$filename", Type=>$attachments{$filename}, Encoding => $encoding);
	}
    } else {
	# Append body
	push @msgdata, "$mail_body";
    }

    # Pipe to sendmail
    open(SM, "|$SENDMAIL -f'$mail_from'") or printError("Error opening sendmail: $!");
    if($mime) { print SM $mime->stringify; }
    else { print SM @msgdata; }
    close(SM);

    # Delete attachments
    if(keys %attachments) {
	for(keys %attachments) {
	    unlink("$USERDIR/attachments/$_");
	}
    }

    # Go back to inbox with an alert box saying it's been sent
    listMail("sendmail");
}

sub viewAddressBook {
    logAction("viewing address book");
    tie(my %addrbook, 'DB_File', "$USERDIR/addrbook.db", O_RDWR|O_CREAT, 0644, $DB_HASH) or
	printError("Error opening address book: $!");
    printHeader();
    printMenuBar("Address Book");
    print <<EOF;
<p>
<input type=hidden name=addrbook_name_old value="">
<input type=hidden name=addrbook_email_old value="">
<input type=hidden name=addrbook_name_delete value="">
<input type=hidden name=addrbook_to value="">
<table border=0 align=center width=95% cellspacing=1 cellpadding=1>
  <tr><th align=left bgcolor="#D3DCE3">Name (click to edit)</th><th align=left bgcolor="#D3DCE3">Email Address (click to mail)</th><th align=center bgcolor="#D3DCE3">Action</th></tr>
  <tr><td bgcolor="#EEEEEE"><input type=text size=40 name=addrbook_name></td>
      <td bgcolor="#EEEEEE"><input type=text size=40 name=addrbook_email></td>
      <td bgcolor="#EEEEEE" align=center><input type=submit name=submitbutton value="Add/Modify" onClick='document.Form1.submitfunction.value="addAddressBook";'></td>
  </tr>
EOF

    my $count = 0;
    for my $key (sort { lc($a) cmp lc($b) } keys(%addrbook)) {
	$count++;
	my $bgcolor = ($count % 2)?"#EEEEEE":"#DDDDDD";
	print <<EOF;
<tr>
  <td bgcolor="$bgcolor">
    <a href='#' title='Edit $key' onClick='document.Form1.addrbook_name.value="$key"; document.Form1.addrbook_name_old.value="$key"; document.Form1.addrbook_email_old.value="$addrbook{$key}"; document.Form1.addrbook_email.value="$addrbook{$key}";'>$key</a>
  </td>
  <td bgcolor="$bgcolor">
    <a href='javascript: composeMail("$key");' title='Compose Message to $key'>$addrbook{$key}</a>
  </td>
  <td bgcolor="$bgcolor" align=center>
    <input type=submit name=submitbutton value="Delete" onClick='document.Form1.submitfunction.value="delAddressBook"; document.Form1.addrbook_name_delete.value="$key";'>
  </td>
</tr>
EOF
    }

    print <<EOF;
</table>
</p>
EOF
    untie(%addrbook);
    printFooter();
}

sub addAddressBook {
    logAction("adding to address book");
    my $addrbook_name = $cgi->param('addrbook_name')?$cgi->param('addrbook_name'):"";
    $addrbook_name =~ s/^\s+//;
    $addrbook_name =~ s/\s+$//;
    unless($addrbook_name) { printError("No name specified"); }
    my $addrbook_email = $cgi->param('addrbook_email')?$cgi->param('addrbook_email'):"";
    $addrbook_email =~ s/[<|>]//g;
    $addrbook_email =~ s/^\s+//;
    $addrbook_email =~ s/\s+$//;
    unless($addrbook_email) { printError("No email address specified"); }
    my $addrbook_name_old = $cgi->param('addrbook_name_old')?$cgi->param('addrbook_name_old'):"";
    my $addrbook_email_old = $cgi->param('addrbook_email_old')?$cgi->param('addrbook_email_old'):"";

    # Sanity Checks
    unless($addrbook_email =~ /\@/) { printError("Invalid email address"); }
    if($addrbook_email =~ /\s/) { printError("Email address cannot have spaces"); }
    if($addrbook_name =~ /'/) { printError("Name cannot have apostrophes"); }
    if($addrbook_name =~ /"/) { printError("Name cannot have quotation marks"); }

    # Add/Modify entry
    tie(my %addrbook, 'DB_File', "$USERDIR/addrbook.db", O_RDWR|O_CREAT, 0644, $DB_HASH) or
	printError("Error opening address book: $!");
    $addrbook{$addrbook_name} = $addrbook_email;
    if(!($addrbook_name ne $addrbook_name_old and $addrbook_email ne $addrbook_email_old) and $addrbook_name ne $addrbook_name_old) {
	# We're modifying the Name field, but not both Name and Email, so it's a "modify"
	delete $addrbook{$addrbook_name_old};
    }
    untie(%addrbook);
    viewAddressBook();
}

sub delAddressBook {
    logAction("deleting from address book");
    my $addrbook_name = $cgi->param('addrbook_name_delete')?$cgi->param('addrbook_name_delete'):"";
    unless($addrbook_name) { printError("No address book entry specified"); }
    tie(my %addrbook, 'DB_File', "$USERDIR/addrbook.db", O_RDWR|O_CREAT, 0644, $DB_HASH) or
	printError("Error opening address book: $!");
    delete $addrbook{$addrbook_name};
    untie(%addrbook);
    viewAddressBook();
}

sub listAddressBook {
    logAction("listing address book");
    my $field = shift;
    unless($field eq "to" or $field eq "cc" or $field eq "bcc") { printError("Invalid address book field: '$field'"); }
    my @rcpt_list = $cgi->param('rcpt_list')?split(/,/, $cgi->param('rcpt_list')):();
    my %rcpts;
    for (@rcpt_list) {
	my ($sender_name, $sender_addr) = spasm::tools::email2nameaddr($_);
	$rcpts{$sender_addr}{sender_name} = $sender_name;
    }

    tie(my %addrbook, 'DB_File', "$USERDIR/addrbook.db", O_RDWR|O_CREAT, 0644, $DB_HASH) or
	printError("Error opening address book: $!");
    print <<EOF;
Content-type: text/html

<html>
  <head>
    <style type="text/css">$CSS</style>
    <script type="text/javascript">
      function Update(email) {
	var addrlist = "";
	for (var i=0; i<document.addrbookForm.elements.length; i++) {
	  var e = document.addrbookForm.elements[i];
	  if ((e.name == "$field" && e.checked) || e.value == email || e.name == "otheremail") {
	    if(addrlist) addrlist += ",";
	    addrlist += e.value;
	  }
	}
	window.opener.document.Form1.mail_$field.value = addrlist;
	window.close();
      }
    </script>
  </head>
  <body>
    <table border=0 align=center width=95% cellpadding=0 cellspacing=0>
      <tr><td bgcolor="#002266"><font color="#FFFFFF"><b>Address Book</b></font></td></tr>
    </table>
    <form action=$SCRIPT method=post name=addrbookForm>
      <p>
      <table border=0 align=center width=95% cellpadding=0 cellspacing=0>
EOF

    my $i = 0;
    for my $key (sort { lc($a) cmp lc($b) } keys(%addrbook)) {
	unless($i % 2) { print "<tr>"; }
	my $checked = "";
	if($rcpts{"$addrbook{$key}"}) { $checked = "checked"; $rcpts{"$addrbook{$key}"}{checked} = 1; }
	print <<EOF;
  <td bgcolor='#EEEEEE' align=left><input type=checkbox name='$field' value='&quot;$key&quot; &lt;$addrbook{$key}&gt;' $checked>
    <a href="javascript:Update('&quot;$key&quot; &lt;$addrbook{$key}&gt;')">$key</a>
  </td>
EOF
	if($i % 2) { print "</tr>"; }
	$i++;
    }

    print "</table></p><p>\n";

    for my $key (keys(%rcpts)) {
	unless($rcpts{$key}{checked}) {
	    print "<input type=hidden name=otheremail value='&quot;$rcpts{$key}{sender_name}&quot; &lt;$key&gt;'>\n";
        }
    }

    print <<EOF;
	<center>
	  <input type=submit name=submitbutton value="Continue" onClick="Update(); return false;">
	  <input type=submit name=submitbutton value="Cancel" onClick="window.close();">
	</center>
      </p>
    </form>
  </body>
</html>
EOF
    untie(%addrbook);
}

sub viewPrefs {
    logAction("viewing prefs");
    tie(my %prefs, 'DB_File', "$USERDIR/prefs.db", O_RDWR|O_CREAT, 0644, $DB_HASH) or
	printError("Error opening preferences: $!");
    my $reply_to = $prefs{reply_to}?$prefs{reply_to}:"";
    if($reply_to) { $reply_to = spasm::tools::str2html($reply_to); }
    my $signature = $prefs{signature}?$prefs{signature}:"";
    my $default_email = $prefs{default_email}?$prefs{default_email}:"";
    my $bcc_self = $prefs{bcc_self} || '';
    my $new_compose_window = $prefs{new_compose_window} || '';
    my $delete_reported_spam = $prefs{delete_reported_spam} || '';
    my $confirm_delete = $prefs{confirm_delete} || '';
    my $confirm_spam = $prefs{confirm_spam} || '';
    my $refresh_inbox = $prefs{refresh_inbox} || '';
    untie(%prefs);

    my $default_email_menu = "<select name=default_email>";
    tie(%prefs, 'DB_File', "$USERDIR/email_addresses.db", O_RDWR|O_CREAT, 0644, $DB_HASH) or
	printError("Error opening email address database: $!");
    for my $key (sort keys(%prefs)) {
        my $selected = "";
        if($prefs{$key}) {
            $selected = ($default_email eq "\"$prefs{$key}\" <$key>")?"selected":"";
            $default_email_menu .= qq|<option value='&quot;$prefs{$key}&quot; &lt;$key&gt;' $selected>&quot;$prefs{$key}&quot; &lt;$key&gt;</option>|;
        } else {
            $selected = ($default_email eq "<$key>")?"selected":"";
            $default_email_menu .= qq|<option value='&lt;$key&gt;' $selected>&lt;$key&gt;</option>|;
        }
    }
    untie(%prefs);
    $default_email_menu .= "</select>";

    my $bcc_self_menu = "<select name=bcc_self>";
    for my $key ("no", "yes") {
	my $selected = ($bcc_self eq $key)?"selected":"";
	$bcc_self_menu .= qq|<option value="$key" $selected>$key</option>|;
    }                  
    $bcc_self_menu .= "</select>";

    my $compose_window_menu = "<select name=new_compose_window>";
    for my $key ("no", "yes") {
        my $selected = ($new_compose_window eq $key)?"selected":"";
        $compose_window_menu .= qq|<option value="$key" $selected>$key</option>|;
    }
    $compose_window_menu .= "</select>";

    my $delete_reported_spam_menu = "<select name=delete_reported_spam>";
    for my $key ("no", "yes") {
        my $selected = ($delete_reported_spam eq $key)?"selected":"";
        $delete_reported_spam_menu .= qq|<option value="$key" $selected>$key</option>|;
    }
    $delete_reported_spam_menu .= "</select>";

    my $confirm_delete_menu = "<select name=confirm_delete>";
    for my $key ("yes", "no") {
        my $selected = ($confirm_delete eq $key)?"selected":"";
        $confirm_delete_menu .= qq|<option value="$key" $selected>$key</option>|;
    }
    $confirm_delete_menu .= "</select>";

    my $confirm_spam_menu = "<select name=confirm_spam>";
    for my $key ("yes", "no") {
        my $selected = ($confirm_spam eq $key)?"selected":"";
        $confirm_spam_menu .= qq|<option value="$key" $selected>$key</option>|;
    }
    $confirm_spam_menu .= "</select>";

    my $refresh_inbox_menu = "<select name=refresh_inbox>";
    for my $key ("Off", "5", "15", "30") {
	my $selected = ($refresh_inbox eq $key)?"selected":"";
	$refresh_inbox_menu .= qq|<option value="$key" $selected>$key</option>|;
    }
    $refresh_inbox_menu .= "</select>";

    printHeader();
    printMenuBar("Options");
    print <<EOF;
<p>
  <table border=0 align=center width=95% cellspacing=1 cellpadding=1>
    <tr><td colspan=2 bgcolor="#D3DCE3"><b>Personal Information</b></td></tr>
    <tr><td width=50% align=right bgcolor="#DDDDDD"><b>Default Email Address:</b></td>
	<td width=50% align=left bgcolor="#DDDDDD">$default_email_menu <a href='javascript: submitFunction("viewEmailAddresses", 0);' title="Edit Email Addresses"><img align="absmiddle" src=$GFX/mail_froms.png border=0 alt="Edit Email Addresses"></a></td></tr>
    <tr><td width=50% align=right bgcolor="#DDDDDD"><b>Reply-To:</b></td>
	<td width=50% align=left bgcolor="#DDDDDD"><input type=text size=40 name=reply_to value="$reply_to"></td></tr>
    <tr><td width=50% align=right bgcolor="#DDDDDD"><b>BCC self when sending messages:</b></td>
        <td width=50% align=left bgcolor="#DDDDDD">$bcc_self_menu</td></tr>
    <tr><td width=50% align=right bgcolor="#DDDDDD"><b>Compose in new window:</b></td>
	<td width=50% align=left bgcolor="#DDDDDD">$compose_window_menu</td></tr>
    <tr><td width=50% align=right bgcolor="#DDDDDD"><b>Automatically delete reported spam:</b></td>
	<td width=50% align=left bgcolor="#DDDDDD">$delete_reported_spam_menu</td></tr>
    <tr><td width=50% align=right bgcolor="#DDDDDD"><b>Confirm when deleting messages:</b></td>
        <td width=50% align=left bgcolor="#DDDDDD">$confirm_delete_menu</td></tr>
    <tr><td width=50% align=right bgcolor="#DDDDDD"><b>Confirm when reporting spam:</b></td>
        <td width=50% align=left bgcolor="#DDDDDD">$confirm_spam_menu</td></tr>
    <tr><td width=50% align=right bgcolor="#DDDDDD"><b>Auto-Refresh Inbox (in minutes):</b></td>
	<td width=50% align=left bgcolor="#DDDDDD">$refresh_inbox_menu</td></tr>
    <tr><td colspan=2 align=center bgcolor="#DDDDDD"><b>Signature (500 characters or less)</b><br>
	<textarea name="signature" rows="5" cols="78" wrap="hard">$signature</textarea><br>&nbsp;</td></tr>
  </table>
</p>
<p>
  <table border=0 align=center width=95% cellspacing=1 cellpadding=1>
    <tr><td align=center bgcolor="#DDDDDD"><input type=submit name=submitbutton value="Save" onClick='document.Form1.submitfunction.value="savePrefs";'></td></tr>
  </table>
</p>
EOF
    printFooter();
}

sub savePrefs {
    logAction("saving prefs");

    # Sanity checks...
    if($cgi->param('reply_to') and $cgi->param('reply_to') !~ /\@/) { printError("Reply-To must be a fully qualified email address!"); }

    # Save it...
    tie(my %prefs, 'DB_File', "$USERDIR/prefs.db", O_RDWR|O_CREAT, 0644, $DB_HASH) or
        printError("Error opening preferences: $!");
    $prefs{reply_to} = $cgi->param('reply_to') || '';
    $prefs{signature} = $cgi->param('signature') || '';
    $prefs{default_email} = $cgi->param('default_email') || '';
    $prefs{bcc_self} = $cgi->param('bcc_self') || 'no';
    $prefs{new_compose_window} = $cgi->param('new_compose_window') || 'no';
    $prefs{delete_reported_spam} = $cgi->param('delete_reported_spam') || 'no';
    $prefs{confirm_delete} = $cgi->param('confirm_delete') || 'yes';
    $prefs{confirm_spam} = $cgi->param('confirm_spam') || 'yes';
    $prefs{refresh_inbox} = $cgi->param('refresh_inbox') || 'no';
    untie(%prefs);

    viewPrefs();
}

sub viewEmailAddresses {
    logAction("viewing email addresses");
    tie(my %addrbook, 'DB_File', "$USERDIR/email_addresses.db", O_RDWR|O_CREAT, 0644, $DB_HASH) or
	printError("Error opening email address database: $!");
    printHeader();
    printMenuBar("Personal Email Addresses");
    print <<EOF;
<p>
<input type=hidden name=addrbook_name_old value="">
<input type=hidden name=addrbook_email_old value="">
<input type=hidden name=addrbook_email_delete value="">
<table border=0 align=center width=95% cellspacing=0 cellpadding=0>
  <tr><th align=left bgcolor="#D3DCE3">Email Address (click to edit)</th><th align=left bgcolor="#D3DCE3">Name</th><th align=center bgcolor="#D3DCE3">Action</th></tr>
  <tr><td bgcolor="#EEEEEE"><input type=text size=40 name=addrbook_email></td>
      <td bgcolor="#EEEEEE"><input type=text size=40 name=addrbook_name></td>
      <td bgcolor="#EEEEEE" align=center><input type=submit name=submitbutton value="Add/Modify" onClick='document.Form1.submitfunction.value="addEmailAddress";'></td>
  </tr>
EOF

    for my $key (sort keys(%addrbook)) {
	print <<EOF;
<tr>
  <td bgcolor="#EEEEEE">
    <a href='#' title='Edit $key' onClick='document.Form1.addrbook_email.value="$key"; document.Form1.addrbook_email_old.value="$key"; document.Form1.addrbook_name_old.value="$addrbook{$key}"; document.Form1.addrbook_name.value="$addrbook{$key}";'>$key</a>
  </td>
  <td bgcolor="#EEEEEE">$addrbook{$key}</td>
  <td bgcolor="#EEEEEE" align=center>
    <input type=submit name=submitbutton value="Delete" onClick='document.Form1.submitfunction.value="delEmailAddress"; document.Form1.addrbook_email_delete.value="$key";'></tr>
  </td>
EOF
    }

    print <<EOF;
</table>
</p>
EOF
    untie(%addrbook);
    printFooter();
}

sub addEmailAddress {
    logAction("adding email address");
    my $addrbook_name = $cgi->param('addrbook_name')?$cgi->param('addrbook_name'):"";
    $addrbook_name =~ s/^\s+//;
    my $addrbook_email = $cgi->param('addrbook_email')?$cgi->param('addrbook_email'):"";
    $addrbook_email =~ s/[<|>]//g;
    $addrbook_email =~ s/^\s+//;
    unless($addrbook_email) { printError("No email address specified"); }
    my $addrbook_email_old = $cgi->param('addrbook_email_old')?$cgi->param('addrbook_email_old'):"";
    my $addrbook_name_old = $cgi->param('addrbook_name_old')?$cgi->param('addrbook_name_old'):"";

    # Sanity Checks
    unless($addrbook_email =~ /\@/) { printError("Invalid email address"); }
    if($addrbook_email =~ /\s/) { printError("Email address cannot have spaces"); }

    # Add/Modify entry
    tie(my %addrbook, 'DB_File', "$USERDIR/email_addresses.db", O_RDWR|O_CREAT, 0644, $DB_HASH) or
	printError("Error opening email address database: $!");
    $addrbook{$addrbook_email} = $addrbook_name;
    if(!($addrbook_email ne $addrbook_email_old and $addrbook_name ne $addrbook_name_old) and $addrbook_email ne $addrbook_email_old) {
	# We're modifying the Email field, but not both Email and Name, so it's a "modify"
	delete $addrbook{$addrbook_email_old};
    }
    untie(%addrbook);
    viewEmailAddresses();
}

sub delEmailAddress {
    logAction("deleting email address");
    my $addrbook_email = $cgi->param('addrbook_email_delete')?$cgi->param('addrbook_email_delete'):"";
    unless($addrbook_email) { printError("No address book entry specified"); }
    tie(my %addrbook, 'DB_File', "$USERDIR/email_addresses.db", O_RDWR|O_CREAT, 0644, $DB_HASH) or
        printError("Error opening emaila address database: $!");
    delete $addrbook{$addrbook_email};
    untie(%addrbook);
    viewEmailAddresses();
}

sub reportSpam {
    logAction("reporting spam");
    my $lastfunction = $cgi->param('lastfunction') || "";
    my @msgs = $cgi->param('messagelist');
    unless(@msgs) { printError("No messages to report"); }
    if($lastfunction eq "viewMessage" and !$cgi->param('viewmessage')) { printError("Message inconsistency detected. Please notify support."); }

    tie(my %prefs, 'DB_File', "$USERDIR/prefs.db", O_RDWR|O_CREAT, 0644, $DB_HASH) or
        printError("Error opening preferences: $!");
    my $delete_reported_spam = $prefs{delete_reported_spam} || '';
    untie(%prefs);

    my $reported_headers = "";
    my $headers;
    my $pop = connectPOP3() or printError("Error connecting to POP server");
    if($DOMAINS{$domain}{emaillogin}) {
        $pop->login("$username\@$DOMAINS{$domain}{domain}", $password) or
            printError("Invalid Username or Password.");
    } else {
        $pop->login($username, $password) or
            printError("Invalid Username or Password.");
    }
    for my $viewmessage (@msgs) {
	my ($n, $u) = split(/:/, $viewmessage, 2);
	my $uidl = $pop->uidl($n);
	next unless $u and $uidl;
	next if $u ne $uidl;
	my $hdrs = $pop->top($n);
        # Verify that the recipient has SF_LOCALFILTER turned on
        my $skip = 0;
        my $xrcpt = 0;
        for(@$hdrs) {
            if(/^X-spasm-sender-IP: (\d+)\.(\d+)\.(\d+)\.(\d+)/) {
                my $ip1 = $1; my $ip2 = $2; my $ip3 = $3; my $ip4 = $4;
                my $lookup = `$SPASM_CGI_APP lookup_blacklist localbl $ip1`;
		chomp $lookup;
                if($lookup) { $skip = 1; warn "Blocked report from blacklisted address"; last; }
                $lookup = `$SPASM_CGI_APP lookup_blacklist localbl $ip1.$ip2`;
		chomp $lookup;
                if($lookup) { $skip = 1; warn "Blocked report from blacklisted address"; last; }
                $lookup = `$SPASM_CGI_APP lookup_blacklist localbl $ip1.$ip2.$ip3`;
		chomp $lookup;
                if($lookup) { $skip = 1; warn "Blocked report from blacklisted address"; last; }
            }
            if(/^X-spasm: SF_LOCALFILTER/) {
                # Message was already filtered
                warn "Blocked report from filtered message";
                $skip = 1;
            }
            if(/^X-spasm-rcpt: $/) {
                # Recipient had no filters set
                warn "Blocked report from unfiltered account";
                $skip = 1;
            }
            if(/^X-spasm-rcpt: (.+)$/) {
                my $rcpt = $1;
                my $fltr = `$SPASM_CGI_APP lookup_filter $rcpt SF_LOCALFILTER`;
                chomp $fltr;
                if($fltr == 0 or $fltr == 8) {
                    warn "Blocked report from unfiltered account: $rcpt";
                    $skip = 1;
                }
                $xrcpt = 1;
            }
        }
        unless($xrcpt) {
            my $rcpt = "$username\@$DOMAINS{$domain}{domain}";
            my $fltr = `$SPASM_CGI_APP lookup_filter $rcpt SF_LOCALFILTER`;
            chomp $fltr;
            if($fltr == 0 or $fltr == 8) {
                warn "Blocked report from unfiltered account: $rcpt";
                $skip = 1;
            }
        }
        if($skip) {
            if($delete_reported_spam eq "yes") {
                $pop->delete($n);
            }
            next;
        }
	for (@$hdrs) {
	    $headers = join('', @$hdrs);
	}
	$reported_headers .= "$headers\n\n";

        # Delete if necessary
        if($delete_reported_spam eq "yes") {
            $pop->delete($n);
        }
    }
    $pop->quit;
    # Send report if there are valid headers
    if($reported_headers) {
	open(SM, "|$SENDMAIL -f'$SPAM_REPORT'") or printError("Error opening sendmail: $!");
	print SM <<EOF;
From: Spam Report <$SPAM_REPORT>
To: Spam Report <$SPAM_REPORT>
Subject: Spam Report
X-spasm-webmail: Spam Report
X-spasm-webmail-reporter: $username\@$domain

$reported_headers
EOF
	close(SM);
    }
    if($lastfunction eq "viewMessage") { viewMessage("spamreport"); }
    else { listMail("spamreport"); }
}
